
    module estimation
      use precisions
      use types_generic
      use routines_generic
      use types
      use globalvalues
      
    contains
!--------------------------------------------------------------------------!
!--------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
     subroutine readinmomentsdata(consdata,consdatasd, workprop, workpropsd)
     use globalvalues !for getpaths  
     implicit none
        
        character (80) :: path_in
        character (80) :: path_out
        character (80) :: in_consinwork_educ1
        character (80) :: in_consinwork_educ2
        character (80) :: in_consinwork_educ3
        character (80) :: in_consnotinwork_educ1
        character (80) :: in_consnotinwork_educ2
        character (80) :: in_consnotinwork_educ3

        character (80) :: in_sdconsinwork_educ1
        character (80) :: in_sdconsinwork_educ2
        character (80) :: in_sdconsinwork_educ3
        character (80) :: in_sdconsnotinwork_educ1
        character (80) :: in_sdconsnotinwork_educ2
        character (80) :: in_sdconsnotinwork_educ3
        
        character (80) :: in_ft_educ1
        character (80) :: in_ft_educ2
        character (80) :: in_ft_educ3
        character (80) :: in_pt_educ1
        character (80) :: in_pt_educ2
        character (80) :: in_pt_educ3
        character (80) :: in_sdft_educ1
        character (80) :: in_sdft_educ2
        character (80) :: in_sdft_educ3
        character (80) :: in_sdpt_educ1
        character (80) :: in_sdpt_educ2
        character (80) :: in_sdpt_educ3
        
        
        real (kind=rk), intent(out) :: consdata(14,3)
        real (kind=rk), intent(out) :: consdatasd(14,3)
        real (kind=rk), intent(out) :: workprop(16,3)
        real (kind=rk), intent(out) :: workpropsd(16,3)
        
        call getpaths(path_in, path_out)
        in_consinwork_educ1           = trim(path_in) // 'expgrowthinwork1.txt'
        in_consinwork_educ2           = trim(path_in) // 'expgrowthinwork2.txt'
        in_consinwork_educ3           = trim(path_in) // 'expgrowthinwork3.txt'
        in_consnotinwork_educ1        = trim(path_in) // 'expgrowthnotinwork1.txt'
        in_consnotinwork_educ2        = trim(path_in) // 'expgrowthnotinwork2.txt'
        in_consnotinwork_educ3        = trim(path_in) // 'expgrowthnotinwork3.txt'
        in_sdconsinwork_educ1         = trim(path_in) // 'sdexpgrowthinwork1.txt'
        in_sdconsinwork_educ2         = trim(path_in) // 'sdexpgrowthinwork2.txt'
        in_sdconsinwork_educ3         = trim(path_in) // 'sdexpgrowthinwork3.txt'
        in_sdconsnotinwork_educ1      = trim(path_in) // 'sdexpgrowthnotinwork1.txt'
        in_sdconsnotinwork_educ2      = trim(path_in) // 'sdexpgrowthnotinwork2.txt'
        in_sdconsnotinwork_educ3      = trim(path_in) // 'sdexpgrowthnotinwork3.txt'

        in_ft_educ1 = trim(path_in) // 'ft1.txt'
        in_ft_educ2 = trim(path_in) // 'ft2.txt'
        in_ft_educ3 = trim(path_in) // 'ft3.txt'
        in_pt_educ1 = trim(path_in) // 'pt1.txt'
        in_pt_educ2 = trim(path_in) // 'pt2.txt'
        in_pt_educ3 = trim(path_in) // 'pt3.txt'
        in_sdft_educ1 = trim(path_in) // 'sdft1.txt'
        in_sdft_educ2 = trim(path_in) // 'sdft2.txt'
        in_sdft_educ3 = trim(path_in) // 'sdft3.txt'
        in_sdpt_educ1 = trim(path_in) // 'sdpt1.txt'
        in_sdpt_educ2 = trim(path_in) // 'sdpt2.txt'
        in_sdpt_educ3 = trim(path_in) // 'sdpt3.txt'
        
!---------------------------------------!
!Bring in moments on consumption
!---------------------------------------!
!First the moments - will be followed by standard errors

        open (unit=40, file=in_consinwork_educ1, action='read')
        read (40, *) consdata(1:9,1)
        close (40) 

        open (unit=40, file=in_consnotinwork_educ1, action='read')
        read (40, *) consdata(10:14,1)
        close (40) 

        open (unit=40, file=in_consinwork_educ2, action='read')
        read (40, *) consdata(1:9,2)
        close (40) 

        open (unit=40, file=in_consnotinwork_educ2, action='read')
        read (40, *) consdata(10:14,2)
        close (40) 

        open (unit=40, file=in_consinwork_educ3, action='read')
        read (40, *) consdata(1:9,3)
        close (40) 

        open (unit=40, file=in_consnotinwork_educ3, action='read')
        read (40, *) consdata(10:14,3)
        close (40) 

!Now standard errors

        open (unit=40, file=in_sdconsinwork_educ1, action='read')
        read (40, *) consdatasd(1:9,1)
        close (40) 

        open (unit=40, file=in_sdconsnotinwork_educ1, action='read')
        read (40, *) consdatasd(10:14,1)
        close (40) 

        open (unit=40, file=in_sdconsinwork_educ2, action='read')
        read (40, *) consdatasd(1:9,2)
        close (40) 

        open (unit=40, file=in_sdconsnotinwork_educ2, action='read')
        read (40, *) consdatasd(10:14,2)
        close (40) 

        open (unit=40, file=in_sdconsinwork_educ3, action='read')
        read (40, *) consdatasd(1:9,3)
        close (40) 

        open (unit=40, file=in_sdconsnotinwork_educ3, action='read')
        read (40, *) consdatasd(10:14,3)
        close (40) 


!---------------------------------------!
!Bring in moments on labour supply
!---------------------------------------!
        open (unit=40, file=in_ft_educ1, action='read')
        read (40, *) workprop(1:8,1)
        close (40) 

        open (unit=40, file=in_pt_educ1, action='read')
        read (40, *) workprop(9:16,1)
        close (40) 

        open (unit=40, file=in_ft_educ2, action='read')
        read (40, *) workprop(1:8,2)
        close (40) 

        open (unit=40, file=in_pt_educ2, action='read')
        read (40, *) workprop(9:16,2)
        close (40) 

        open (unit=40, file=in_ft_educ3, action='read')
        read (40, *) workprop(1:8,3)
        close (40) 

        open (unit=40, file=in_pt_educ3, action='read')
        read (40, *) workprop(9:16,3)
        close (40) 
        
        !----------------------------------------------!
        !Now bring in the standard errors
        !----------------------------------------------!
        open (unit=40, file=in_sdft_educ1, action='read')
        read (40, *) workpropsd(1:8,1)
        close (40) 

        open (unit=40, file=in_sdpt_educ1, action='read')
        read (40, *) workpropsd(9:16,1)
        close (40) 

        open (unit=40, file=in_sdft_educ2, action='read')
        read (40, *) workpropsd(1:8,2)
        close (40) 

        open (unit=40, file=in_sdpt_educ2, action='read')
        read (40, *) workpropsd(9:16,2)
        close (40) 

        open (unit=40, file=in_sdft_educ3, action='read')
        read (40, *) workpropsd(1:8,3)
        close (40) 

        open (unit=40, file=in_sdpt_educ3, action='read')
        read (40, *) workpropsd(9:16,3)
        close (40) 

     end subroutine readinmomentsdata
! ---------------------------------------------------------------------------------------------------------!
       
     subroutine formatmomentdata(consdataraw, consdataforest, workdataraw,workdataforest)
       implicit none
       
       !Arguments
       real (kind=rk), intent(in) :: consdataraw(48,3)
       real (kind=rk), intent(out) :: consdataforest(10,3)
       real (kind=rk), intent(in) :: workdataraw(26,3)
       real (kind=rk), intent(out) :: workdataforest(14,3)
        
       !For program
       integer :: ixcounter
       integer :: ixed
       integer :: ix
       
       !----------------------------------------------------------------------------!
       !Consumption
       !----------------------------------------------------------------------------!
       
       do ixed = 1, 3, 1
           ix = 1
           do ixcounter = 1, 41, 5
               consdataforest(ix , ixed) = (consdataraw(ixcounter, ixed) + consdataraw(ixcounter + 1, ixed) + consdataraw(ixcounter +2, ixed) &
                                            + consdataraw(ixcounter + 3, ixed) + consdataraw(ixcounter + 4, ixed))/5
               ix = ix + 1
           end do
               ixcounter = 46
               consdataforest(ix , ixed) = (consdataraw(ixcounter, ixed) + consdataraw(ixcounter + 1, ixed) + consdataraw(ixcounter +2, ixed))/3
       end do

       !----------------------------------------------------------------------------!
       !Work
       !----------------------------------------------------------------------------!
       
       do ixed = 1, 3, 1
           ix = 1
           do ixcounter = 1, 16, 5
               workdataforest(ix , ixed) = (workdataraw(ixcounter, ixed) + workdataraw(ixcounter + 1, ixed) + workdataraw(ixcounter +2, ixed) &
                                            + workdataraw(ixcounter + 3, ixed) + workdataraw(ixcounter + 4, ixed))/5
               ix = ix + 1
          end do
               ixcounter = 21
               workdataforest(ix , ixed) = (workdataraw(ixcounter, ixed) + workdataraw(ixcounter + 1, ixed) + workdataraw(ixcounter +2, ixed) &
                                            + workdataraw(ixcounter + 3, ixed) + workdataraw(ixcounter + 4, ixed) + workdataraw(ixcounter + 5, ixed))/6
       !workdataforest(:, ixed) = workdataraw(:, ixed)
       end do

     end subroutine formatmomentdata
     
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
       
     subroutine formatmomentsims(numyears, consdatainwork, consdataoutofwork, consdataforest, consdataforest_touse, ftraw, ptraw, workdataforest)
       implicit none
       
       !Arguments
       integer, intent(in) :: numyears
       real (kind=rk), intent(in) :: consdatainwork(numyears)
       real (kind=rk), intent(in) :: consdataoutofwork(numyears)
       real (kind=rk), intent(out) :: consdataforest(14)
       logical, intent(out) :: consdataforest_touse(14)
       real (kind=rk), intent(in) :: ftraw(numyears)
       real (kind=rk), intent(in) :: ptraw(numyears)
       real (kind=rk), intent(out) :: workdataforest(16) 
       
       !For program
       integer :: ixcounter
       integer :: ixed
       integer :: ix
       integer :: firstageindata, firstageinsims, firstindexinsims
       real (kind=rk) :: consdataboth(numyears, 2)
       real (kind=rk) :: consdataveragesoveryears(10, 2)
       real (kind=rk) :: averagepropinwork(10)
       real (kind=rk) :: consdataveragesgrowth(9,2)
       logical :: consdataveragesgrowth_touse(9,2)      
       real (kind=rk) :: consdataforest_includingnotused(18)
       logical :: consdataforest_touse_includingnotused(18)
       
       integer ::  ageatsimindex, ixaveragecounter, ixinworknotinwork, ixavegrowthragecounter, ixconsdatatouse
       
       !------------------------------------------------!
       !Consumption
       !------------------------------------------------!
        !Put both consumption vectors in one matrix
        consdataboth(:, 1) = consdataoutofwork 
        consdataboth(:, 2) = consdatainwork
             
           ixaveragecounter = 1
           firstageindata = 25
           firstageinsims = 20
       
       !Get the average consumption in five year bands    
           firstindexinsims = firstageindata - firstageinsims + 1         
           ixcounter =  firstindexinsims
           ageatsimindex = firstageindata !Just to get into the loop
           do ixaveragecounter = 1, 10, 1                      
               do ixinworknotinwork = 1, 2, 1
               consdataveragesoveryears(ixaveragecounter, ixinworknotinwork) = (consdataboth(ixcounter, ixinworknotinwork) + & 
                                                                         consdataboth(ixcounter + 1 , ixinworknotinwork) + &  
                                                                         consdataboth(ixcounter + 2, ixinworknotinwork) + & 
                                                                         consdataboth(ixcounter + 3, ixinworknotinwork) + & 
                                                                         consdataboth(ixcounter + 4, ixinworknotinwork) )/10
                                                                         

                end do  !ixinworknotinwork                                                                       
                                                                         
                !Get average proportion in each of these age groups - this is to assess whether to use the particular moment or not - only need to do this once
                   averagepropinwork(ixaveragecounter) = (ftraw(ixcounter) + ptraw(ixcounter) + & 
                                                                             ftraw(ixcounter + 1)+ ptraw(ixcounter+1) + &  
                                                                             ftraw(ixcounter + 2)+ ptraw(ixcounter+1) + & 
                                                                             ftraw(ixcounter + 3)+ ptraw(ixcounter+1) + & 
                                                                             ftraw(ixcounter + 4)+ ptraw(ixcounter+1) )/ 10
                                                                                                                                                                                 
                                                                                                      
               ageatsimindex = ageatsimindex + 5
               ixcounter = ixcounter + 5
           end do !ageatsimindex

       !Now get the growth in average consumption
           do ixavegrowthragecounter = 1, 9, 1       
            do ixinworknotinwork = 1, 2, 1
              consdataveragesgrowth(ixavegrowthragecounter, ixinworknotinwork) = (consdataveragesoveryears(ixavegrowthragecounter + 1, ixinworknotinwork)/  &
                                                                           consdataveragesoveryears(ixavegrowthragecounter , ixinworknotinwork) ) - 1 
            end do !ixinworknotinwork                                                                               
            
              !Now get logicals in the same shape as consdataveragesgrowth which will be true if the proportion in work is large enough to work and vice versa
                   consdataveragesgrowth_touse(ixavegrowthragecounter,1) = .true. !Out of work - use all the out of work people
              if ((averagepropinwork(ixavegrowthragecounter).gt.0.025_rk).and.(averagepropinwork(ixavegrowthragecounter+1).gt.0.025_rk)) then          
                    consdataveragesgrowth_touse(ixavegrowthragecounter,2) = .true. !In work
              else                 
                    consdataveragesgrowth_touse(ixavegrowthragecounter,2) = .false. !In work
              end if

           end do


        consdataforest_includingnotused = reshape(consdataveragesgrowth, (/18/))
        consdataforest_touse_includingnotused =reshape(consdataveragesgrowth_touse, (/18/))
        
        !I am not using the growth rates for 'not in work' for ages 30 to 45 (4 observations). Drop these
        do ixconsdatatouse = 1, 14
           consdataforest(ixconsdatatouse) = consdataforest_includingnotused(ixconsdatatouse+4)
           consdataforest_touse(ixconsdatatouse) = consdataforest_touse_includingnotused(ixconsdatatouse+4)
        end do    
       
        !------------------------------------------------!
        !Work
        !------------------------------------------------!
        ix = 1
           firstageindata = 35
           firstageinsims = 20
           
           firstindexinsims = firstageindata - firstageinsims + 1
        !----------!    
        !Full-time
        !----------!    
           do ixcounter = firstindexinsims, firstindexinsims + 30, 5
               workdataforest(ix) = (ftraw(ixcounter) + ftraw(ixcounter + 1) + ftraw(ixcounter +2)+ ftraw(ixcounter +3) + ftraw(ixcounter +4))/5.0_rk
               ix = ix + 1
           end do
            
            
               ixcounter = firstindexinsims + 35
               workdataforest(ix) = (ftraw(ixcounter) + ftraw(ixcounter + 1) + ftraw(ixcounter +2))/3._rk
               ix = ix + 1
               
        !----------!    
        !Part-time
        !----------!            
           do ixcounter = firstindexinsims, firstindexinsims + 30, 5
               workdataforest(ix) = (ptraw(ixcounter) + ptraw(ixcounter + 1) + ptraw(ixcounter +2)  + ptraw(ixcounter +3)  + ptraw(ixcounter +4))/5.0_rk
               ix = ix + 1
           end do
               ixcounter = firstindexinsims + 35
               workdataforest(ix) = (ptraw(ixcounter) + ptraw(ixcounter + 1) + ptraw(ixcounter +2))/3.0_rk
        
        
               
     end subroutine formatmomentsims
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
     subroutine getagridsofparams(numparams, lowerbounds, upperbounds, numpoints, grid)
       implicit none

!******* input variables *******
        integer, intent (in) :: numparams
        real (kind=rk), intent (in) :: lowerbounds(numparams)
        real (kind=rk), intent (in) :: upperbounds(numparams)
        integer, intent (in) :: numpoints


!******* output variable *******
        real (kind=rk), dimension (numpoints, numparams) :: grid

!******* local variables *******
        integer :: ixi, ixj, ixparam
        
        do ixparam = 1, numparams
            call getnodes(grid(:, ixparam),lowerbounds(ixparam), upperbounds(ixparam), numpoints, 0.0_rk)
        end do

    end subroutine getagridsofparams

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
          subroutine getmoments_grid(m, n, params, moments, sumofsquares, points,allearnings, assgrid, pengrid, dcgrid, ar1pmat, cumulgrid, policy, exval, &
                ixtype, numsims, ar1shocks, ar1cdf, doprintsimdetail, discountfrom1,opt_realised, consdata, consdatasd, workdataforest, workdataforestsd)
       implicit none
       
       !Arguments that follow the NAG structure       
       integer, intent(in) :: m !Number of moments
       integer, intent(in) :: n !Number of parameters
       real (kind=rk), intent(in) :: params(n) !the parameters -  xc in documentation
       real (kind=rk), intent(out) :: moments(m) !Will be the moments - fvec in documentation
       real (kind=rk), intent(out) :: sumofsquares


      !Other arguments (for vfi or simulate
      type (grids) :: points
      real (kind=rk), intent (in) :: allearnings(points%labopt, points%ar1by4, points%numyears)
      real (kind=rk), intent (in) :: assgrid(points%ass, points%numyears+1)
      real (kind=rk), intent (in) :: pengrid(points%pen)
      real (kind=rk), intent (in) :: dcgrid(points%dc, points%maxretage-19)
      real (kind=rk), intent (in) :: ar1pmat(points%ar1by4, points%ar1by4, points%numyears)
      real (kind=rk), intent (in) :: cumulgrid(points%cum, points%maxretage-19)
      type (policy_funcs), intent (inout) :: policy
      type (val_funcs), intent (inout) :: exval
      integer, intent(in) :: ixtype
      integer, intent (in) :: numsims
      real (kind=rk), intent (in) :: ar1shocks(points%ar1by4, points%numyears)
      real (kind=rk), intent (in) :: ar1cdf(points%ar1by4, points%ar1by4, points%numyears)
      logical, intent(in) :: doprintsimdetail
      real (kind=rk), intent(in) :: discountfrom1(points%numyears)
      type(typeopt_realisations), intent(in)  :: opt_realised(numtypes)
      real (kind=rk), intent(in) :: consdata(14,3)
      real (kind=rk), intent(in) :: consdatasd(14,3)
      real (kind=rk), intent(in) :: workdataforest(16,3)
      real (kind=rk), intent(in) :: workdataforestsd(16,3)
      
      !For programme - not going to be used by vfi or simulate requires them
      integer :: sdffail(4)
      real (kind=rk) :: sdffailprop(4)
      integer :: failbyyear(points%numyears, 4)
      real (kind=rk) :: failpropbyyear(points%numyears, 4)
      real (kind=rk) :: failmaxoversims(4)
      real (kind=rk) :: failaveoversims(4)
      type (seriesstats) :: simstat
      real (kind=rk) :: expdiscutil(numtypes)
      real (kind=rk) :: allcpaths(points%numyears, numsims)
      integer :: alllpaths(points%numyears, numsims)
      integer :: allhhcomps(points%numyears, numsims)
      real (kind=rk) :: govtbalance(numtypes)   

       !For programme
       integer :: todayage
       integer :: ixyear
       integer :: ix
       integer :: index
       
       !Formatted simulated data
       real (kind=rk) :: consdataforest_sims(14)
       logical  :: consdataforest_touse_sims(14)
       real (kind=rk) :: workdataforest_sims(16)

       
       !For NAG
       integer :: ifail
       real (kind=rk) :: g01eaf
       
       !Set the parameters
      points%params%beta = params(1) 
      points%params%cweight_base = params(2) 
      points%params%fixedcost_base = params(3) 
      
       ifail = 0
       
       
       !Print the parameters
       write(*,*) (params)       
       
      
      moments = 0.0_rk
       
        !Solve and simulate
                   
        call vfi(points, allearnings,ar1pmat, assgrid, dcgrid, pengrid, cumulgrid, opt_realised(ixtype), policy, exval, sdffail, &
          sdffailprop,failbyyear,failpropbyyear)      
   
        call simulate(points, ixtype, points%sims, allearnings, ar1shocks, ar1pmat, ar1cdf, doprintsimdetail, assgrid, &
            dcgrid, pengrid, cumulgrid, policy, exval, discountfrom1,opt_realised(ixtype),failmaxoversims, failaveoversims, simstat, &
            expdiscutil(ixtype),allcpaths,alllpaths, allhhcomps, govtbalance(ixtype))
      
      
        call formatmomentsims(points%numyears, simstat%coninwork%mean, simstat%conoutofwork%mean,  consdataforest_sims,consdataforest_touse_sims, &
                                    simstat%ft%mean,simstat%pt%mean,  workdataforest_sims)
               
               sumofsquares = 0.0_rk
               do ix = 1, 14
                    if (consdataforest_touse_sims(ix)) then
                    moments(ix) = (consdata(ix,ixtype) - consdataforest_sims(ix))/consdatasd(ix,ixtype)                     
                    sumofsquares = sumofsquares +  moments(ix)* moments(ix) 
                    end if
               end do
              
               do ix = 15, 30
                    index = ix- 14                    
                    moments(ix) = ((workdataforest(index,ixtype) - workdataforest_sims(index)))/workdataforestsd(index,ixtype)                    
                    sumofsquares = sumofsquares +  moments(ix)* moments(ix) 
               end do
               

              
       write(*,*) moments 
       write(*,*) 'sum of squares is', sumofsquares 
       write(*,*)               
                  
end subroutine getmoments_grid

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!


end module estimation