! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
    module routines_specific
      use routines_generic
      use precisions
      use types_generic
      use globalvalues
      
      implicit none

    contains
        
    
!---------------------------------------------------------------------------------------------------------!
      subroutine readinpoints(allpoints, numkids, numeqkids, earnparams, opt_realised, unemprates)
        implicit none
!---------------------------------------------------------------------------------------------------------!
!---------------------------------------------------------------------------------------------------------!
        type (grids), intent (out) :: allpoints(numtypes)
        real (kind=rk), intent(out) :: numkids(numyears, numtypes)
        real (kind=rk), intent(out) :: numeqkids(numyears, numtypes)
        real (kind=rk), intent(out), optional :: earnparams(6, numtypes)
        type(typeopt_realisations), intent(inout), optional  :: opt_realised(numtypes)
        real (kind=rk), intent(out) :: unemprates(numtypes)
!---------------------------------------------------------------------------------------------------------!

        ! Will be intent(out)

        
        integer :: ixtype
        character (80) :: path_in
        character (80) :: path_out
        character (80) :: in_points
        character (80) :: in_numkids
        character (80) :: in_earnparams
        character (80) :: in_fixedeffects
        character (80) :: in_growthrates
        character (80) :: in_realisedearnings
        character (80) :: in_realisedunemp 
        character (80) :: in_manshare
        character (80) :: in_dcgr
        character (80) :: in_unemprates
        character (80) :: in_yob
        character (80) :: in_cashData, in_housData, in_nonpenData
        character (80) :: in_penData
        character (80) :: in_survprobs_m, in_survprobs_f           
        character (80) :: in_dbcoeffs, in_statepencoeffs, in_fedecile, in_edType, in_aveFe, in_hasDB, in_hous, in_betaEst
        real (kind=rk) :: readindata(59)
        real (kind=rk) :: missingSurvM, missingSurvF
        integer :: ixdchoice
        integer :: ixtoday, todayage
        integer :: typesforloop 
        integer :: ifail
        real (kind=rk) :: aveFE(numtypes)
        real (kind=rk) :: hasDBForLogical, hasHousForLogical
        real (kind=rk) :: infoFromBetaEstFile(3, numtypes)
        real (kind=rk), dimension(numyears) :: homogsurvprobs_m, homogsurvprobs_f
        
!Arguments
        call getpaths(path_in, path_out)

     
        
        in_points = trim(path_in) // 'points.txt'
        open (unit=110, file=in_points, action='read')
    
        in_numkids = trim(path_in) // 'numkids.txt'
        open (unit=111, file=in_numkids, action='read')

        in_earnparams = trim(path_in) // 'earnparams.txt'
        open (unit=112, file=in_earnparams, action='read')

        in_realisedearnings = trim(path_in) // 'realisedearnings.txt'
        open (unit=115, file=in_realisedearnings, action='read')

        in_realisedunemp = trim(path_in) // 'realisedunemp.txt'
        open (unit=116, file=in_realisedunemp, action='read')

        in_manshare = trim(path_in) // 'manshare.txt'
        open (unit=117, file=in_manshare, action='read')

        in_manshare = trim(path_in) // 'manshare.txt'
        open (unit=118, file=in_manshare, action='read')
        
        in_dcgr = trim(path_in) // 'dcgr.txt'
        open (unit=123, file=in_dcgr, action='read')
          
        in_unemprates = trim(path_in) // 'unemprates.txt'
        open (unit=155, file=in_unemprates, action='read')

        in_yob = trim(path_in) // 'yob.txt'
        open (unit=160, file=in_yob, action='read')

        in_nonpenData = trim(path_in) // 'realisednpwealth.txt'
        open (unit=165, file=in_nonpenData, action='read')

        in_cashData = trim(path_in) // 'realisedcash.txt' 
        open (unit=166, file=in_cashData, action='read')

        in_housData = trim(path_in) // 'realisedHousing.txt'
        open (unit=167, file=in_housData, action='read')
        
        in_penData = trim(path_in) // 'realisedpwealth.txt'
        open (unit=175, file=in_penData, action='read')
                        
        in_dbcoeffs = trim(path_in) // 'dbprocessparam_sim.txt'
        open (unit=195, file=in_dbcoeffs, action='read')

        in_statepencoeffs = trim(path_in) // 'statepenprocessparam.txt'
        open (unit=205, file=in_statepencoeffs, action='read')
                     
        in_fedecile = trim(path_in) // 'fedecile.txt'
        open (unit=215, file=in_fedecile, action='read')
        
        in_edType = trim(path_in) // 'type.txt'
        open (unit=225, file=in_edType, action='read')

        in_aveFe = trim(path_in) // 'avfe.txt'
        open (unit=235, file=in_aveFe, action='read')
        
        in_hasDB = trim(path_in) // 'hasdb.txt'
        open (unit=245, file=in_hasDB, action='read')

        in_hous = trim(path_in) // 'hasHous.txt'
        open (unit=255, file=in_hous, action='read')
        
        if (homogSurvProbs) then
            in_survprobs_m = trim(path_in) // 'survprobs_m.txt'
            open (unit=401, file=in_survprobs_m, action='read')
               
            in_survprobs_f = trim(path_in) // 'survprobs_f.txt'
            open (unit=402, file=in_survprobs_f, action='read')
        else   
            in_survprobs_m = trim(path_in) // 'survprobsAll_m.txt'
            open (unit=401, file=in_survprobs_m, action='read')
               
            in_survprobs_f = trim(path_in) // 'survprobsAll_f.txt'
            open (unit=402, file=in_survprobs_f, action='read')
        end if
        
        in_betaEst = trim(path_in) // 'foundBetas.txt'
        open (unit=410, file=in_betaEst, action='read')
        

		        
        
!For programme
        do ixtype = 1, 1
        
        allpoints(ixtype)%sims = 1
        
         read (110, *) readindata

         if (timeSaving) then
            allpoints(ixtype)%ass = 20 
            allpoints(ixtype)%dc = 20 
            allpoints(ixtype)%ar1 = 20
         else             
            allpoints(ixtype)%ass = int(readindata(1))  
            allpoints(ixtype)%dc = int(readindata(2))  
            allpoints(ixtype)%ar1 = int(readindata(3))  
         end if
          allpoints(ixtype)%goldentol = 10**(readindata(4))
          allpoints(ixtype)%unemppay = readindata(5)          
          allpoints(ixtype)%dcmeanret = readindata(6) 
          allpoints(ixtype)%dcstdev = readindata(7)
          
          if (noPenTaxAdv) then
            allpoints(ixtype)%dclumpsumprop = 0.0_rk
          else
            allpoints(ixtype)%dclumpsumprop = readindata(8)
          end if
            allpoints(ixtype)%rate = readindata(9)
          allpoints(ixtype)%dcquad%dim = int(readindata(10))
          
          !Get numdcchoicesint
          allpoints(ixtype)%numdcch = 1          
          if (dcOverRide) then ! This forces DC off - by only allowing a contribution of zero
              allpoints(ixtype)%numdcch = 1 
              allocate (allpoints(ixtype)%alldcchoice(allpoints(ixtype)%numdcch))
              allpoints(ixtype)%alldcchoice(1) = 0.0_rk
          else
              do ixdchoice = 2, 10 
                if (readindata(12+ixdchoice).gt.0.0001_rk) allpoints(ixtype)%numdcch = allpoints(ixtype)%numdcch + 1
              end do
                        
              allocate (allpoints(ixtype)%alldcchoice(allpoints(ixtype)%numdcch))
              do ixdchoice = 1, allpoints(ixtype)%numdcch
                allpoints(ixtype)%alldcchoice(ixdchoice) = readindata(12+ixdchoice)
              end do
          end if  
         

        allpoints(ixtype)%maxdccont = maxval(allpoints(ixtype)%alldcchoice)

        allpoints(ixtype)%tax2005%tfa = readindata(23)
        allpoints(ixtype)%tax2005%higherthreshold = readindata(24)
        allpoints(ixtype)%tax2005%basicrate = readindata(25)
        allpoints(ixtype)%tax2005%higherrate = readindata(26)
          
        allpoints(ixtype)%params%beta = 1/(1 + allpoints(ixtype)%rate) 
        allpoints(ixtype)%params%gamma = 3.0_rk

        
        
        !If gamma ~=1 then I'll save this value to speed things up
         if (.not.((allpoints(ixtype)%params%gamma.gt.(1.0_rk-1.0d-2)).and.(allpoints(ixtype)%params%gamma.lt.(1.0_rk+1.0d-2)))) then
             allpoints(ixtype)%params%oneminusgamma = 1.0_rk - allpoints(ixtype)%params%gamma
             allpoints(ixtype)%params%oneover1minusgamma = 1/(1-allpoints(ixtype)%params%gamma)
         end if 
        
        allpoints(ixtype)%pc%guarcredon = readinlogical(readindata(29), 29)
        allpoints(ixtype)%pc%capflowrate = readindata(30)
        allpoints(ixtype)%pc%capdisreg = readindata(31)
        allpoints(ixtype)%pc%eligage = readindata(32)
        allpoints(ixtype)%pc%level = readindata(33)
        allpoints(ixtype)%pc%savcredon = readinlogical(readindata(34), 34)
        allpoints(ixtype)%pc%sceligage = int(readindata(35))
         allpoints(ixtype)%pc%taper = readindata(36)
         allpoints(ixtype)%pc%oneminustaper = 1.0_rk - allpoints(ixtype)%pc%taper
         allpoints(ixtype)%pc%scthreshold = readindata(37)
         allpoints(ixtype)%pc%maxsavcred = (allpoints(ixtype)%pc%level  - &
                                            allpoints(ixtype)%pc%scthreshold) * allpoints(ixtype)%pc%oneminustaper 
         allpoints(ixtype)%pc%maxincforsavcred = allpoints(ixtype)%pc%level + &
                                                allpoints(ixtype)%pc%maxsavcred / allpoints(ixtype)%pc%taper
         allpoints(ixtype)%statepenage = int(readindata(38))
         
         allpoints(ixtype)%tax2005%statepenage = int(readindata(38)) !I store the state pension age in the tax system structure

         allpoints(ixtype)%pc%levelcoup = readindata(39)
         allpoints(ixtype)%pc%scthresholdcoup = readindata(40)
         
         allpoints(ixtype)%pc%maxsavcredcoup = (allpoints(ixtype)%pc%levelcoup  - &
                                            allpoints(ixtype)%pc%scthresholdcoup) * allpoints(ixtype)%pc%oneminustaper 
         allpoints(ixtype)%pc%maxincforsavcredcoup = allpoints(ixtype)%pc%levelcoup + &
                                                allpoints(ixtype)%pc%maxsavcredcoup / allpoints(ixtype)%pc%taper          
         allpoints(ixtype)%dontchecksdfs  = readinlogical(readindata(41), 41)
         allpoints(ixtype)%dontdovalfuncsigncheck = readinlogical(readindata(42), 42)        
         allpoints(ixtype)%unemprisk = readindata(43)        
         allpoints(ixtype)%useequivscale = readinlogical(readindata(44), 44)
         
         allpoints(ixtype)%penpropinherit = readindata(45)
         allpoints(ixtype)%params%multFelByEquiv = readinlogical(readindata(46), 46)  
         allpoints(ixtype)%tax2005%childBenRate1 = readindata(48)         
         allpoints(ixtype)%tax2005%childBenRate2 = readindata(49)
         
         
         
         allpoints(ixtype)%tax2005%lel = readindata(50)
         allpoints(ixtype)%tax2005%uel = readindata(51)
         allpoints(ixtype)%tax2005%NIlower = readindata(52)
         allpoints(ixtype)%tax2005%NIhigher = readindata(53)
         allpoints(ixtype)%tax2005%startinglimit = readindata(54)
         allpoints(ixtype)%tax2005%startingrate = readindata(55)      
         
         allpoints(ixtype)%tax2005%tfa6574 = readindata(56)      
         allpoints(ixtype)%tax2005%tfa75plus = readindata(57)              
 
         
         allpoints(ixtype)%annAdminLoad = readindata(58)
         allpoints(ixtype)%unempKids = readindata(59)

                   


         
         
        ! Elements that are read in from globals or set with refeence to the existing pointsfile
         
            allpoints(ixtype)%mortR = mortR 

             allpoints(ixtype)%housCG = housCG
             allpoints(ixtype)%housYield = housYield
            
            allpoints(ixtype)%portb0 = portb0
            allpoints(ixtype)%portwealth = portwealth
            allpoints(ixtype)%portwealth2 = portwealth2
            allpoints(ixtype)%lev0 = lev0
            allpoints(ixtype)%lev1 = lev1
            allpoints(ixtype)%lev2 = lev2                                                   
          allpoints(ixtype)%pen =  allpoints(ixtype)%dc
          allpoints(ixtype)%ar1by2 = allpoints(ixtype)%ar1*2         
          allpoints(ixtype)%ar1by3 = allpoints(ixtype)%ar1*3    
          allpoints(ixtype)%ar1by4 = allpoints(ixtype)%ar1*4               

          allpoints(ixtype)%oneminusdclumpsumprop = 1.0_rk - allpoints(ixtype)%dclumpsumprop
          allpoints(ixtype)%uncondtrans = uncondTrans         
          allpoints(ixtype)%numyears = numyears
          allpoints(ixtype)%worktorule = .false.
          allpoints(ixtype)%housPoints = allpoints(ixtype)%ass
          allpoints(ixtype)%numhhcomp = 3
         allpoints(ixtype)%womanearnprop = 0.0_rk ! harcoding this - redundant
         if (allpoints(ixtype)%womanearnprop .lt.0.000000001_rk) then
             allpoints(ixtype)%nosepwomanearn = .true.
             allpoints(ixtype)%womannoworkprob(1) = 1.0_rk
             allpoints(ixtype)%womannoworkprob(2) = 1.0_rk         

             allpoints(ixtype)%lowerar1nodeforint = allpoints(ixtype)%ar1by2 + 1
            allpoints(ixtype)%upperar1nodeforint = allpoints(ixtype)%ar1by4    
         else
            allpoints(ixtype)%nosepwomanearn = .false.
            allpoints(ixtype)%lowerar1nodeforint = 1
            allpoints(ixtype)%upperar1nodeforint = allpoints(ixtype)%ar1by4    
                write(*,*) 'need to set womannoworkprob if womanearnprop is zero'
                stop
         end if             
         allpoints(ixtype)%tax2005%taxInterest = taxInterest
         allpoints(ixtype)%optimMethod = optimMethod  
         
        
         allpoints(ixtype)%cons = consGridSize
         allpoints(ixtype)%equivHousingFlow  = .false.         
         allpoints(ixtype)%multOnHousingFlow = 1.0_rk
         allpoints(ixtype)%usesurvprob =  useSurvProbs         
         allpoints(ixtype)%integrateoutsideoptimisation = .true.
         allpoints(ixtype)%firstageatwhichdeath = firstageatwhichdeath 

                  


       
        end do

       
       if (homogSurvProbs) then
            read (401, *) homogsurvprobs_m
            read (402, *) homogsurvprobs_f
        end if
  
! Now read in elements that vary by household

           do ixtype = 1, numtypes
                !Now read in number of children          
                read (111, *) numkids(:, ixtype)
                 
                
                if (present(earnparams)) then
                   read (112, *) earnparams(:, ixtype)
                end if
                if (unempOff) then
                    unemprates = 0.0_rk
                else                    
                    read (155,*) unemprates(ixtype)
                end if
                
                    
                !Now read in a vector of earnings parameters for each individual        
                read (115, *) opt_realised(ixtype)%realisedearnings               
                read (116, *) opt_realised(ixtype)%realisedunemp
                read (117, *) opt_realised(ixtype)%manshare
                read (123, *) opt_realised(ixtype)%dcgr               
                read (160, *) opt_realised(ixtype)%yob
                                                         
                                
                read (165, *) opt_realised(ixtype)%npData                                           
                read (166, *) opt_realised(ixtype)%cashData 
                read (167, *) opt_realised(ixtype)%housData 
                read (175, *) opt_realised(ixtype)%penData
                
                !Read in manshare (male earnings share) into points too - but in a different channel to avoid issues with opening and closing
                allocate (allpoints(ixtype)%manshare(numyears))
                read (118, *) allpoints(ixtype)%manshare           

                ! Read in estimates of beta. There are three columns here, the first one is a the household number. The second is the estimate of beta. The third is a success indicator
                read (410, *)  infoFromBetaEstFile(:, ixtype)
                
           end do !ixtype

!!-------------------------------------------------------!
!!! Populate the rest of poinst with what's in points(1)
!!-------------------------------------------------------!
            do ixtype = 2, numtypes
              allpoints(ixtype) = allpoints(1)
            end do
      
!!-------------------------------------------------------!
!! Do the individual components of points
!!-------------------------------------------------------!
read (235, *) aveFE !Average fixed effect
 
do ixtype = 1, numtypes 
        allpoints(ixtype)%earn%params(1) = earnparams(1,ixtype)
        allpoints(ixtype)%earn%params(2) = earnparams(2,ixtype)
        allpoints(ixtype)%earn%params(3) = earnparams(3,ixtype)
        allpoints(ixtype)%earn%ar1rho = earnparams(4,ixtype)
        allpoints(ixtype)%earn%ar1stdev = earnparams(5,ixtype)**0.5       
        allpoints(ixtype)%unemprisk = unemprates(ixtype)                          
        allpoints(ixtype)%numkids = numkids(:, ixtype) 
        call calequivscale(numyears, numkids(:, ixtype) , allpoints(ixtype)%numeqkids ) 
        allpoints(ixtype)%numeqkids = allpoints(ixtype)%numeqkids ! This stops the warning that I haven't assigned a value here
        
        
        ! Read in DB coefficients and state pension coefficients
        read (195, *) allpoints(ixtype)%dbcoeffs(:)
        read (205, *) allpoints(ixtype)%statepencoeffs(:)                             

        read (215, *) allpoints(ixtype)%fedecile
        read (225, *) allpoints(ixtype)%edType
        read (245, *) hasDBForLogical
        allpoints(ixtype)%hasdb  = readinlogical(hasDBForLogical, 99)
        read (255, *) hasHousForLogical
        if (everyoneHasHousing) then   
             allpoints(ixtype)%hasHous  = .true.
        else            
            allpoints(ixtype)%hasHous  = readinlogical(hasHousForLogical, 99)
        end if
        
       ! Set the interest rate 
        if (intRateOverRide) then    
            allpoints(ixtype)%intMeth = intMeth  
        else
            if (allpoints(ixtype)%hasHous) then
                allpoints(ixtype)%intMeth = 2
            else
                allpoints(ixtype)%intMeth = 1
            end if 
        end if 

        !---------------------!
        ! Survival Probabilities                   
        !---------------------!
        
        if (homogSurvProbs) then
            allpoints(ixtype)%survprobs_m = homogsurvprobs_m
            allpoints(ixtype)%survprobs_f = homogsurvprobs_f            
        else            
            read (401, *) allpoints(ixtype)%survprobs_m
            read (402, *) allpoints(ixtype)%survprobs_f
        end if
        
        missingSurvM = 1.0_rk
        missingSurvF = 1.0_rk

        do ixtoday = 1, numyears, 1
            todayage = ixtoday + 19
            if (todayage.lt.allpoints(ixtype)%firstageatwhichdeath) then
                missingSurvM = missingSurvM * allpoints(ixtype)%survprobs_m(ixtoday)
                missingSurvF = missingSurvF * allpoints(ixtype)%survprobs_f(ixtoday)        
            end if
        end do

        do ixtoday = 1, numyears, 1
            todayage = ixtoday + 19
            if (todayage.lt.allpoints(ixtype)%firstageatwhichdeath) then
                allpoints(ixtype)%survprobs_f(ixtoday) = 1.0_rk
                allpoints(ixtype)%survprobs_m(ixtoday) = 1.0_rk
            end if
            if (todayage.eq.allpoints(ixtype)%firstageatwhichdeath) then
                allpoints(ixtype)%survprobs_f(ixtoday) = missingSurvF * allpoints(ixtype)%survprobs_f(ixtoday)
                allpoints(ixtype)%survprobs_m(ixtoday) = missingSurvM * allpoints(ixtype)%survprobs_m(ixtoday)
            end if
        end do

        
        do ixtoday = 1, numyears , 1
            todayage = ixtoday + 19
            if (todayage.lt.allpoints(ixtype)%firstageatwhichdeath) then
            allpoints(ixtype)%survprobs_f(ixtoday) = 1.0_rk
            allpoints(ixtype)%survprobs_m(ixtoday) = 1.0_rk
            end if                    
        end do
        
        !Definite death in last period
        allpoints(ixtype)%survprobs_m(numyears) = 0.0_rk
        allpoints(ixtype)%survprobs_f(numyears) = 0.0_rk
        
        
        
        ! Get population parmater for each type
        allpoints(ixtype)%earnPop = allpoints(ixtype)%earn
        ! Now replace the fixed effect with the average fixed 
        allpoints(ixtype)%earnPop%params(1) = aveFE(ixtype)
        
        
        
        
        ! Use previously estimated beta either as a starting point for estimation or for solution and simulation if we are not estimating
        if ((useInputtedBetaAsStartingPoint) .or. (usePreviousEstimatedBeta)) then
            allpoints(ixtype)%params%beta = infoFromBetaEstFile(2, ixtype)
        end if 
        
        

        
        
 end do
 


        call checkpoints
      contains
        
        logical function readinlogical(realoneorzero, whichvalinallpoints, oneistrueallothersfalse)
          implicit none
          
          real (kind=rk) :: realoneorzero
          integer :: whichvalinallpoints
          logical, optional :: oneistrueallothersfalse
          logical :: inprogoneistrueallothersfalse
          
          if (present(oneistrueallothersfalse)) then
          	inprogoneistrueallothersfalse = oneistrueallothersfalse
          else 
          	inprogoneistrueallothersfalse = .false.
          end if
          
          if (inprogoneistrueallothersfalse) then
             if ((realoneorzero.gt.0.999_rk) .and. (realoneorzero.lt.1.001_rk)) then
                readinlogical  = .true.
              else
                readinlogical = .false.
              end if
          else     
              if ((realoneorzero.gt.-0.001_rk) .and. (realoneorzero.lt.0.001_rk)) then
                readinlogical = .false.
              else if ((realoneorzero.gt.0.999_rk) .and. (realoneorzero.lt.1.001_rk)) then
                readinlogical  = .true.
              else
                write (*, *) 'error in readindata - an element should be either zero or 1'
                write (*, *) 'element is', whichvalinallpoints
                stop
              end if
          end if
          
        end function readinlogical

        subroutine checkpoints
          implicit none

          do ixtype = 1, numtypes

            if (allpoints(ixtype)%alldcchoice(allpoints(ixtype)%numdcch).ne.allpoints(ixtype)%maxdccont) then
              write (*, *) 'Warning'
              write (*, *) 'Type', ixtype
              write (*, *) 'The top point in dc menu is not equal to specified maxdccont.'
              write (*, *) 'The latter has been set to the former'
              allpoints(ixtype)%maxdccont = allpoints(ixtype)%alldcchoice(allpoints(ixtype)%numdcch)
            end if


    
            if ((allpoints(ixtype)%pc%savcredon).and.( allpoints(ixtype)%pc%scthreshold.gt.allpoints(ixtype)%pc%level)) then
              write (*, *) 'Error'
              write (*, *) 'Type', ixtype
              write (*, *) 'Saving Threshold is greater than pension credit level and savings credit is turned on'
              stop            
            end if

          end do
        end subroutine checkpoints



      end subroutine readinpoints
!----------------------------------------------------------------------------------------------------------------!      

!----------------------------------------------------------------------------------------------------------------!      
!----------------------------------------------------------------------------------------------------------------!       
! ----------------------------------------------------------------------!
! Get Report card 								      			       !
! ----------------------------------------------------------------------!
      subroutine getreportcard(numyears,firstcall, whichtype, sdffail, sdffailprop,failbyyear,&
                failpropbyyear, sdfsimfailpropmax, sdfsimfailpropav)

        implicit none
        integer, intent (in) :: numyears
        logical, intent (in) :: firstcall
        integer, intent (in) :: whichtype
        integer, intent (in) :: sdffail(4)
        integer, intent (in) :: failbyyear(numyears, 4)
        real (kind=rk), intent (in) ::failpropbyyear(numyears, 4)
        real (kind=rk), intent (in) :: sdffailprop(4)
        real (kind=rk), intent (in) :: sdfsimfailpropmax(4)
        real (kind=rk), intent (in) :: sdfsimfailpropav(4)
    
        !Index, for program
        integer :: ixyear
        
        character (80) :: path_in
        character (80) :: path_out
        character (80) :: out_reportcard


100     format (i15, i10, i10, i10)
110     format (f15.3, f10.3, f10.3, f10.3)

! ----------------------------------------------------------------------!
! First write to screen  						      			       !
! ----------------------------------------------------------------------!
        write (*, *) ' '
        write (*, *) ' '
        write (*, *) '--------------------------------------------------------'
        write (*, *) 'Type', whichtype
        write (*, *) '--------------------------------------------------------'
        write (*, *) ' '
        write (*, *) 'Failure of SDF =1 in policy func, number and prop. of fails across nodes'
        write (*, 100) sdffail
        write (*, 110) sdffailprop

        write (*, *) ' '
        write (*, *) 'Failure of SDF =1 in simulation, ave and max prop. of fails across sim. inds'
        write (*, 110) sdfsimfailpropav
        write (*, 110) sdfsimfailpropmax
        write (*, *) '--------------------------------------------------------'
        write (*, *) ' '
        write (*, *) ' '     

        write (*, *) ' '
        write (*, *) ' '     
        write (*, *) '--------------------------------------------------------'
        

        write (*, *) '--------------------------------------------------------'
        write (*, *) ' '
        write (*, *) ' '     

! ----------------------------------------------------------------------!
! Then write to file					      			       !
! ----------------------------------------------------------------------!

        call getpaths(path_in, path_out)
        out_reportcard = trim(path_out) // 'reportcard.out'

        if (firstcall) then
          open (unit=500, file=out_reportcard, action='write', status='replace')
        else
          open (unit=500, file=out_reportcard, action='write', status='old')
        end if

        write (500, *) ' '
        write (500, *) ' '
        write (500, *) '--------------------------------------------------------'
        write (500, *) 'Type', whichtype
        write (500, *) '--------------------------------------------------------'
        write (500, *) ' '
        write (500, *) 'Failure of SDF =1 in policy func, number and prop. of fails across nodes'
        write (500, 100) sdffail
        write (500, 110) sdffailprop

        write (500, *) ' '
        write (500, *) 'Failure of SDF =1 in simulation, ave and max prop. of fails across sim. inds'
        write (500, 110) sdfsimfailpropav
        write (500, 110) sdfsimfailpropmax
        write (500, *) '--------------------------------------------------------'
        write (500, *) ' '
        write (500, *) ' '

        write (500, *) ' '
        write (500, *) ' '     
        write (500, *) '--------------------------------------------------------'
        
        write (500, *) 'Failure of SDF =1 policy function by year'                
        do ixyear = 1, numyears
             write (500,'(i5)', advance='no') ixyear       
             write (500, 110) failpropbyyear(ixyear, :)
        end do

        write (500, *) '--------------------------------------------------------'
        write (500, *) ' '
        write (500, *) ' '     


      end subroutine getreportcard


! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
! Utility function and associated marginal utility function
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

      real (kind=rk) function felicity(consum, leisure, params)
        implicit none

! Arguments
        real (kind=rk), intent (in) :: consum
        integer, intent (in) :: leisure
        type (utilityparams), intent (in) :: params

! For programme
        real (kind=rk) :: expetal ! exp(eta) * leisure
        real (kind=rk) :: seputilcostofwork
        real (kind=rk) :: equivconsum
        real (kind=rk) :: leishours

     equivconsum = consum*params%equivscaleinv
    if ((params%gamma.gt.(1.0_rk-1.0d-2)).and.(params%gamma.lt.(1.0_rk+1.0d-2))) then
          felicity = log(equivconsum)
    else
         felicity = ((equivconsum)**(1-params%gamma))*params%oneover1minusgamma
    end if
      if (params%multFelByEquiv) felicity = felicity*params%equivscale
        
      
      end function felicity

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
      real (kind=rk) function margfelicity(consum, leisure, params)
        implicit none

! Arguments
        real (kind=rk), intent (in) :: consum
        integer, intent (in) :: leisure
        type (utilityparams), intent (in) :: params

! For programme
        real (kind=rk) :: equivconsum
        real (kind=rk) :: seputilcostofwork
        real (kind=rk) :: leishours
        
       
        equivconsum = consum*params%equivscaleinv
        if ((params%gamma.gt.(1.0_rk-1.0d-2)).and.(params%gamma.lt.(1.0_rk+1.0d-2))) then
            margfelicity = (params%equivscaleinv)*(1/(equivconsum))
        else
            margfelicity = (params%equivscaleinv)*((equivconsum)**(-params%gamma))
        end if

  !Multiply utiliy function by equivalence scale if that option is switched on.
      if (params%multFelByEquiv) then
        margfelicity = margfelicity*params%equivscale
      end if
        


      end function margfelicity

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

          real (kind=rk) function margfelicity_inv(margfelicity,  params)
            implicit none

    ! Arguments
            real (kind=rk), intent (in) :: margfelicity
            type (utilityparams), intent (in) :: params

    
            margfelicity_inv = margfelicity ** (-1/params%gamma)
            

          end function margfelicity_inv

! ---------------------------------------------------------------------------------------------------------!
!  ---------------------------------------------------------------------------------------------------------!
         real (kind=rk) function margfelicity_uninv(margfelicity_inv,  params)
            implicit none

    ! Arguments
            real (kind=rk), intent (in) :: margfelicity_inv
            type (utilityparams), intent (in) :: params

    
            margfelicity_uninv = margfelicity_inv ** (-params%gamma)
            

          end function margfelicity_uninv
!
! ---------------------------------------------------------------------------------------------------------!
! A utility function that:
! 1. Takes today's consumption and labour
! 2. Takes tomorrow's value function
! 3. Knows the transition equations and
! 4. Returns the utility of the choice


      subroutine utility(points, utils, cons, todayinfo, params,tomstates, tomgrids, tomvalfuncs)
        use globalvalues
        use types
        implicit none       

        type (grids), intent (in) :: points
        real (kind=rk), intent (out) :: utils
        real (kind=rk), intent (in) :: cons
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        type (typetomstates), intent (in) :: tomstates
        type (typetomgrids), intent (in) :: tomgrids       
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        
! For the program
        real (kind=rk) :: leftoverasset
        real (kind=rk) :: valofleftoverasset
        real (kind=rk) :: interest
        real (kind=rk) :: scratchcash, scratchhousing
       
           
            leftoverasset = (tomstates%cash - cons) + tomstates%windfall   ! Don't add interest in any more as interest isn't added to the stock of assets - it accrues as income
            
            if (todayinfo%ixage.eq.64) then
                  leftoverasset = leftoverasset -  todayinfo%housingIfOver65             
            end if
            
            valofleftoverasset =  contvalue(points, leftoverasset,tomstates,tomgrids, tomvalfuncs,todayinfo, params)                   
            utils = felicity(cons, todayinfo%leistoday, params)  + params%beta*valofleftoverasset
        

      end subroutine utility

      
!---------------------------------------------------------------------------------------------------------!
!---------------------------------------------------------------------------------------------------------!      
     subroutine eulerForZero(points, euler, cons, todayinfo, params,tomstates, tomgrids, tomvalfuncs)
        use globalvalues
        use types
        implicit none       

        type (grids), intent (in) :: points
        real (kind=rk), intent (out) :: euler
        real (kind=rk), intent (in) :: cons
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        type (typetomstates), intent (in) :: tomstates
        type (typetomgrids), intent (in) :: tomgrids       
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        
! For the program
        real (kind=rk) :: leftoverasset
        real (kind=rk) :: tomLinEmu, tomEmu
        real (kind=rk) :: interest, interest_up
        real (kind=rk) :: scratchcash, scratchhousing
        real (kind=rk) :: margR, totalInterest, totalInterest_up

            
            leftoverasset = (tomstates%cash - cons) + tomstates%windfall

            
            interest = getInterest(leftoverasset,points, todayinfo, scratchcash, scratchhousing, totalInterest = totalInterest)  ! Don't add interest in any more as interest isn't added to the stock of assets - it accrues as income
            interest_up  = getInterest(leftoverasset + 0.1_rk,points, todayinfo, scratchcash, scratchhousing, totalInterest = totalInterest_up)  
            
            margR = (totalInterest_up - totalInterest) / 0.1_rk
            
            if (todayinfo%ixage.eq.64) then
                  leftoverasset = leftoverasset -  todayinfo%housingIfOver65             
            end if
            
            tomLinEmu =  contLinEmu(points, leftoverasset,tomstates,tomgrids, tomvalfuncs,todayinfo, params)                   
            tomEmu = margfelicity_uninv(tomLinEmu, params)
            euler = margfelicity(cons, todayinfo%leistoday, params)  - params%beta*(1+margR)*tomEmu

        

        
        
      end subroutine eulerForZero
!---------------------------------------------------------------------------------------------------------!
!---------------------------------------------------------------------------------------------------------!      


! A utility function that:
! 1. Takes today's consumption and labour
! 2. Takes tomorrow's value function
! 3. Knows the transition equations and
! 4. Returns the utility of the choice

real (kind=rk) function margutility(points, cons, todayinfo, params)
        use globalvalues
        use types
        implicit none       

        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: cons
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        
       margutility = margfelicity(cons, todayinfo%leistoday, params) 
        
end function margutility

! ---------------------------------------------------------------------------------------!
!Get the continuation value 
! ---------------------------------------------------------------------------------------!
      real (kind=rk) function contvalue(points, leftoverasset,tomstates,tomgrids,tomvalfuncs,todayinfo, params)
        use globalvalues
        use types
        implicit none


        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: leftoverasset
        type (typetomgrids), intent (in) :: tomgrids
        type (typetomstates), intent (in) :: tomstates
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        
        ! The probabilities are those that you don't die during todayinfo%ixtoday.
        ! So in evaluating tomorrow's expected value function, we take   points%survprobs3way(*,*todayinfo%ixtoday)     
        
        if (todayinfo%ixage.lt.(points%firstageatwhichdeath)) then
            contvalue = contvaluecondonhhcomp(points, leftoverasset,tomstates,tomgrids, tomvalfuncs,todayinfo,todayinfo%ixhhcomp)
        else
            contvalue =  &
            points%survprobs3way(todayinfo%ixhhcomp, 1, todayinfo%ixtoday)* contvaluecondonhhcomp(points, leftoverasset,tomstates,tomgrids, tomvalfuncs,todayinfo, 1) +  & 
            points%survprobs3way(todayinfo%ixhhcomp, 2, todayinfo%ixtoday)* contvaluecondonhhcomp(points, leftoverasset,tomstates,tomgrids, tomvalfuncs,todayinfo, 2) +  &
            points%survprobs3way(todayinfo%ixhhcomp, 3, todayinfo%ixtoday)* contvaluecondonhhcomp(points, leftoverasset,tomstates,tomgrids, tomvalfuncs,todayinfo, 3) 
            
        end if
              
      end function contvalue



! ---------------------------------------------------------------------------------------!
!Get the continuation value 
! ---------------------------------------------------------------------------------------!
      real (kind=rk) function contLinEmu(points, leftoverasset,tomstates,tomgrids,tomvalfuncs,todayinfo, params)
        use globalvalues
        use types
        implicit none


        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: leftoverasset
        type (typetomgrids), intent (in) :: tomgrids
        type (typetomstates), intent (in) :: tomstates
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        
        ! The probabilities are those that you don't die during todayinfo%ixtoday.
        ! So in evaluating tomorrow's expected value function, we take   points%survprobs3way(*,*todayinfo%ixtoday)     
        
        if (todayinfo%ixage.lt.(points%firstageatwhichdeath)) then
            call linearinterp1(tomgrids%ass,tomvalfuncs%linEmu_pre_adlq(:, todayinfo%ixhhcomp,todayinfo%ixleis,todayinfo%ixdcchoice), points%ass,leftoverasset,contLinEmu, 1, 1)
        else 
            if (callingFromVFI) then
            
                   call linearinterp2_fast(tomgrids%ass,  tomgrids%pen, points%ass, points%pen, leftoverasset, tomstates%pen, contLinEmu, tomvalfuncs%linEmu_post_ap)
            
            else
                
                if (points%intMeth.eq.1) then ! There is no housing grid here, don't want to be interpolating
                    call linearinterp2_fast(tomgrids%ass,  tomgrids%pen, points%ass, points%pen, leftoverasset, tomstates%pen, contLinEmu, tomvalfuncs%linEmu_post_aph(:,:,1))             
                else
                    call linearinterp3(tomgrids%ass,  tomgrids%pen, tomgrids%hous, points%ass, points%pen, points%housPoints, leftoverasset, tomstates%pen, tomstates%hous, contLinEmu, tomvalfuncs%linEmu_post_aph)
                end if
                
            end if
        end if
              
      end function contLinEmu


      

! ---------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------!



! ---------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------!    
    
      real (kind=rk) function contvaluecondonhhcomp(points, leftoverasset,tomstates,tomgrids,tomvalfuncs,todayinfo,tomhhcomp)
        use globalvalues
        use types
        implicit none

        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: leftoverasset
        type (typetomgrids), intent (in) :: tomgrids
        type (typetomstates), intent (in) :: tomstates
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        type (typetodayinfo), intent(in) :: todayinfo
        integer, intent(in) :: tomhhcomp
        
! For the program
        real (kind=rk) :: nextperioddc
        real (kind=rk) :: conttocontvalue
        integer :: ixquad 

        real (kind=rk) :: tomValFunc(points%ass, points%dc)
        real (kind=rk) :: scratchcontvalue
        real (kind=rk) :: temp
        
        real (kind=rk) :: tompen
        
       tompen = tomstates%pen
       
!Get continutation values
        if (todayinfo%ixage.lt.64) then
              contvaluecondonhhcomp = 0.0_rk
                if (todayinfo%dcalreadyintegrated) then 
                    call linearinterp1(tomgrids%ass,tomvalfuncs%eval_pre_adlq(:, tomhhcomp,todayinfo%ixleis,todayinfo%ixdcchoice), points%ass,leftoverasset,scratchcontvalue, 1, 1)
                    contvaluecondonhhcomp = scratchcontvalue
                else           
                    !Loop over the DC draws to work out the continuation value
                    tomValFunc = tomvalfuncs%val_ar1Int_pre_adc(:,:,tomhhcomp)
                    do ixquad = 1, points%dcquad%dim, 1
                      nextperioddc = (1+points%dcquad%abs(ixquad))*tomstates%dc
                        call linearinterp2_fast(tomgrids%ass, tomgrids%dc, points%ass, points%dc, leftoverasset, nextperioddc, &
                          conttocontvalue, tomValFunc) 
                        
                      contvaluecondonhhcomp = contvaluecondonhhcomp + (conttocontvalue*points%dcquad%weigh(ixquad))
                    end do
              end if !dcalreadyintegrated                

        else 
                        
              if ((callingFromVFI).and.(todayinfo%ixage.gt.64)) then ! Unless there is a death, we'll just stay at the same pension gridpoint, so no need for 2d interpolation
                 call linearinterp1(tomgrids%ass, tomvalfuncs%val_post_apc(:,todayinfo%ixpenpoint,tomhhcomp),  points%ass, leftoverasset, contvaluecondonhhcomp,1,1 )                 
              else 
                  if (callingFromVFI) then
                        call linearinterp2_fast(tomgrids%ass,  tomgrids%pen, points%ass, points%pen, leftoverasset, tompen, contvaluecondonhhcomp, tomvalfuncs%val_post_apc(:,:,tomhhcomp))
                   else                   
                       
                        if (points%intMeth.eq.1) then ! There is no housing grid here, don't want to be interpolating
                            call linearinterp2_fast(tomgrids%ass,  tomgrids%pen, points%ass, points%pen, leftoverasset,tompen, contvaluecondonhhcomp, tomvalfuncs%val_post_adch(:,:,1,tomhhcomp))                 
                        else 
                            call linearinterp3(tomgrids%ass,  tomgrids%pen, tomgrids%hous, points%ass, points%pen, points%housPoints, leftoverasset, tompen, tomstates%hous, contvaluecondonhhcomp, tomvalfuncs%val_post_adch(:,:,:,tomhhcomp)  )
                        end if
                   
                   end if
       
                  
             end if

        end if


        
        
      end function contvaluecondonhhcomp


! ---------------------------------------------------------------------------------------!
! This is based on code given in Miranda and Fackler:
! "Applied Computaiontal Economics and Finance"
     real (kind=rk) function golden(points, a, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
        use globalvalues
        use types
        implicit none

! Generic stuff
! Arguments
        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: a
        real (kind=rk), intent (in) :: b
        real (kind=rk), intent (out) :: xmax

! Stuff particular to my utility function
        type (typetomgrids), intent (in) :: tomgrids   
        type (typetomstates), intent (in) :: tomstates
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        

! For program
        real (kind=rk) :: x1
        real (kind=rk) :: x2
        real (kind=rk) :: f1
        real (kind=rk) :: f2
        real (kind=rk) :: diff
        real (kind=rk) :: goldenalpha1
        real (kind=rk) :: goldenalpha2
        parameter (goldenalpha2=0.61803399_rk)
        parameter (goldenalpha1=1._rk-goldenalpha2)
        real (kind=rk) :: tempf1, tempx1, tempf2, tempx2


!Generate the subroutine that generates the various grids for the shortcuts
        x1 = a + goldenalpha1*(b-a)
        x2 = a + goldenalpha2*(b-a)

        call utility(points, f1, x1, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
        call utility(points, f2, x2, todayinfo, params, tomstates, tomgrids,tomvalfuncs)       

        
        
        diff = goldenalpha1*goldenalpha2*(b-a)
        do while (diff.gt.points%goldentol)
          diff = diff*goldenalpha2
          if (f2.lt.f1) then
            x2 = x1
            x1 = x1 - diff

            f2 = f1

            call utility(points, f1, x1, todayinfo, params,tomstates, tomgrids,tomvalfuncs)
          else
            x1 = x2
            x2 = x2 + diff

            f1 = f2

            call utility(points, f2, x2, todayinfo, params,tomstates, tomgrids,tomvalfuncs)
              
          end if
        end do

        if (f2.gt.f1) then
          xmax = x2
          golden = f2
        else
          xmax = x1
          golden = f1
        end if

        if (golden.lt.(-bigdp)) then
          write (*, *) 'optimised value is less than -bigdp'
        !  stop
        end if


      end function golden



! ---------------------------------------------------------------------------------------!
! This is based on code given in Miranda and Fackler:
! "Applied Computaiontal Economics and Finance"
     real (kind=rk) function bisection(points, a, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
        use globalvalues
        use types
        implicit none

! Generic stuff
! Arguments
        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: a
        real (kind=rk), intent (in) :: b
        real (kind=rk), intent (out) :: xmax

! Stuff particular to my utility function
        type (typetomgrids), intent (in) :: tomgrids   
        type (typetomstates), intent (in) :: tomstates
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        

! For program
        real (kind=rk) :: x1
        real (kind=rk) :: x2
        real (kind=rk) :: f1
        real (kind=rk) :: f2
        real (kind=rk) :: dx
        integer :: counter
        

        
!Generate the subroutine that generates the various grids for the shortcuts
        x1 = a 
        x2 = b

        call eulerForZero(points, f1, x1, todayinfo, params,tomstates, tomgrids, tomvalfuncs)   
        call eulerForZero(points, f2, x2, todayinfo, params,tomstates, tomgrids, tomvalfuncs)   
        
        
       
        if(f1.lt.0.0_rk) then !Orient the search so that f>0 lies at x+dx.
            xmax = x1
            dx = x2-x1
        else
            xmax = x2
            dx = x1-x2
        endif
        

        
        counter = 0
        do while ((abs(f2).gt.1d-20).and.(abs(dx).gt.0.01_rk).and.(counter.lt.100))
            dx = dx * 0.5_rk
            x2 = xmax + dx
            call eulerForZero(points, f2, x2, todayinfo, params,tomstates, tomgrids, tomvalfuncs)   
            if (f2.le.0.0_rk) xmax = x2
            counter = counter + 1
           
        end do
      
        bisection = f2
        

        
     end function bisection
     
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
!     
     real (kind=rk) function getMax(points, a, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
        use globalvalues
        use types
        implicit none

! Generic stuff
! Arguments
        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: a
        real (kind=rk), intent (in) :: b
        real (kind=rk), intent (out) :: xmax

! Stuff particular to my utility function
        type (typetomgrids), intent (in) :: tomgrids   
        type (typetomstates), intent (in) :: tomstates
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        

! For program
        real (kind=rk) :: gridOfCons(points%cons)
        real (kind=rk) :: gridOfValues(points%cons)
        real (kind=rk) :: cons
        integer :: ixGrid
        integer :: maxix
        
     if (points%optimMethod.eq.1) then     
            do ixGrid = 1, points%cons, 1
                cons = a + (b-a) * consGrid(ixGrid) 
                gridOfCons(ixGrid) = cons
                call utility(points, gridOfValues(ixGrid), cons, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
            end do
        
            maxix = maxloc(gridOfValues, 1)                      
            getMax = gridOfValues(maxix)
            xmax = gridOfCons(maxix) 
                     
            if (getMax.lt.(-bigdp)) then
              write (*, *) 'optimised value is less than -bigdp'
              stop
            end if
     else if (points%optimMethod.eq.2) then
       getMax =  golden(points, a, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
     else
         write(*,*) 'error in getMax. optimMethod should be 1 or 2'
         stop
     end if                                  
     
     end function getMax

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
    real (kind=rk) function getMax_fast(points, a, b,  guess, doGuess, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
        use globalvalues
        use types
        implicit none

! Generic stuff
! Arguments
        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: a
        real (kind=rk), intent (in) :: b
        real (kind=rk), intent (in) :: guess
        logical, intent (in) :: doGuess
        real (kind=rk), intent (out) :: xmax

! Stuff particular to my utility function
        type (typetomgrids), intent (in) :: tomgrids   
        type (typetomstates), intent (in) :: tomstates
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        

! For program
        real (kind=rk) :: gridOfCons(points%cons)
        real (kind=rk) :: gridOfValues(points%cons)
        real (kind=rk) :: cons, lower, upper
        integer :: ixGrid
        integer :: maxix
        logical :: upperLowered, lowerRaised
        real (kind=rk) :: valConsEverthing, valConsNearlyEverthing, eulerConsumeEverything, eulerConsumeNearlyEverthing
        real (kind=rk) :: euler, zero, tempJan
        logical :: consumeEverything
        
     if (points%optimMethod.eq.1) then     
            do ixGrid = 1, points%cons, 1
                cons = a + (b-a) * consGrid(ixGrid) 
                gridOfCons(ixGrid) = cons
                call utility(points, gridOfValues(ixGrid), cons, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
            end do
        
            maxix = maxloc(gridOfValues, 1)                      
            getMax_fast = gridOfValues(maxix)
            xmax = gridOfCons(maxix) 
                     
            if (getMax_fast.lt.(-bigdp)) then
              write (*, *) 'optimised value is less than -bigdp'
              stop
            end if
     else if (points%optimMethod.eq.2) then
      
        
         consumeEverything = .false.
            
         ! First check if consuming everything is optimal
         if (solveUsingEuler) then
            if (todayinfo%ixage.eq.(points%numyears+19)) then
                consumeEverything = .true.
                call utility(points, valConsEverthing, b, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
                getMax_fast = valConsEverthing
                xmax = b
            else ! We're not in final period
                call eulerForZero(points, eulerConsumeEverything, b, todayinfo, params,tomstates, tomgrids, tomvalfuncs)   
    
                if (eulerConsumeEverything.gt.0) then
                    consumeEverything = .true.
                    call utility(points, valConsEverthing, b, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
                    getMax_fast = valConsEverthing
                    xmax = b
                else
                   consumeEverything = .false.            
                end if 
            end if !if (todayinfo%ixage.eq.(points%numyears+19)) then
         else if (.not.(solveUsingEuler)) then
            call utility(points, valConsEverthing, b, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
            call utility(points, valConsNearlyEverthing, b-1.0_rk, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
            if (valConsEverthing.gt.valConsNearlyEverthing) then
                consumeEverything = .true.
                getMax_fast = valConsEverthing
                xmax = b
            else
                consumeEverything = .false.
            end if                     
         end if
            
         
         if (.not.(consumeEverything)) then
             !!! First do it if we're doing the guuess
             
                  if (doGuess) then
                        !!!------------------  
                          ! Get the lower and upper bounds
                        !!!------------------  
                               if (todayinfo%ixage .gt. 64) then ! A good guess is that won't consume more than equivelent in future period if at back end of lifecycle
                                   upper = guess
                               else 
                                   upper  = guess * (1.0_rk + guessPerturb)
                               end if                               
                               
           
                               if (upper .gt. b) then
                                   upper = b
                                   upperLowered = .false.
                               else
                                   upperLowered = .true.
                               end if
           
                               !Are we raising the top
                               lower = guess * (1.0_rk - guessPerturb)
                               if ((lower.lt.a).or.(lower.gt.b)) then ! I have encountered situations where the new lower bound was greater than the old upper bound
                                 lower = a
                                 lowerRaised = .false.
                               else 
                                 lowerRaised = .true.
                               end if
            
                               
                            
                               
                               !!! Do the optimisation
                               if (solveUsingEuler) then
                                   zero = bisection(points, lower, upper, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
                                   tempJan = xmax
                                   if  ((lowerRaised).and.(xmax.lt.(lower + 1.0_rk))) then
                                        zero = bisection(points, a, upper, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
                                   else if ((upperLowered).and.(xmax.gt.(upper - 1.0_rk))) then
                                        zero = bisection(points, lower, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
                                   
                                   end if
                                call utility(points, getMax_fast, xmax, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
                                
                                
                               else if (.not.(solveUsingEuler)) then
                                getMax_fast =  golden(points, lower, upper, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
                                   ! If we're at a corner, then do a broader search
                                   if  ((lowerRaised).and.(xmax.lt.(lower + 1.0_rk))) then
                                        getMax_fast =  golden(points, a, upper, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
                                   else if ((upperLowered).and.(xmax.gt.(upper - 1.0_rk))) then
                                        getMax_fast =  golden(points, lower, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
                                   end if
                                  
                               end if
                         else if (.not.(doGuess)) then
                              if (solveUsingEuler) then
                                    zero = bisection(points, a, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params) 
                                    call utility(points, getMax_fast, xmax, todayinfo, params, tomstates, tomgrids, tomvalfuncs)
                             else
                                    getMax_fast =  golden(points, a, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
                              end if
                         end if
             end if
         
   
     else
         write(*,*) 'error in getMax. optimMethod should be 1 or 2'
         stop
     end if            
     
  
     
     end function getMax_fast
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

      subroutine getobjectivefunc(points, a, b, xmax,tomstates,tomgrids, tomvalfuncs, todayinfo,params)
        use globalvalues
        use types
        implicit none

! Generic stuff
! Arguments
        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: a !min cons
        real (kind=rk), intent (in) :: b !max cons
        real (kind=rk), intent (out) :: xmax

! Stuff particular to my utility function
        type (typetomgrids), intent (in) :: tomgrids   
        type (typetomstates), intent (in) :: tomstates
        type (typetomvalfuncs), intent (in) :: tomvalfuncs
        type (typetodayinfo), intent(in) :: todayinfo
        type (utilityparams), intent (in) :: params
        

! Grid of consumption and grid of values and other info
        real (kind=rk) :: values(300)
        real (kind=rk) :: cons(300)
        real (kind=rk) :: leftoverA(300), gridA0(300), gridA1(300)
        real (kind=rk) :: valLeftOver(300), margut(300), vprime(300), euler(300)
        real (kind=rk) :: otherinfo(11)

! Index
        integer :: ix, scratch_xnearestloc, xlowerloc

! Strings for paths
        character (80) :: path_in
        character (80) :: path_out
        character (80) :: out_cons
        character (80) :: out_values
        character (80) :: out_leftoverA, out_valLeftOver,out_euler, out_margut,out_vprime, out_gridA0, out_gridA1

        character (80) :: out_details

        real (kind=rk) :: scratchcash, scratchhousing, interest, forderiv1, forderiv2

!  Get consumption grid for today
        call getnodes(cons, a, b-0.00001_rk, 300, 0.0_rk)

!Get the value at each point on the consumption grid
        do ix = 1, 300, 1
            interest = getInterest(tomstates%cash-cons(ix),points, todayinfo, scratchcash, scratchhousing)  
            margut(ix) = margfelicity(cons(ix), todayinfo%leistoday, params)
            leftoverA(ix) = (tomstates%cash-cons(ix)) + tomstates%windfall      ! No longer add interest here - it is part of income
           valLeftOver(ix) =  contvalue(points, leftoverA(ix),tomstates,tomgrids, tomvalfuncs,todayinfo, params)   
           call findingridr(tomgrids%ass, points%ass, leftoverA(ix), scratch_xnearestloc, xlowerloc)           
           gridA0(ix) = tomgrids%ass(xlowerloc)
           gridA1(ix) = tomgrids%ass(xlowerloc + 1)
           forderiv1 = contvalue(points, (leftoverA(ix)+0.1_rk), tomstates,tomgrids, tomvalfuncs,todayinfo, params)
           forderiv2 = contvalue(points, (leftoverA(ix)-0.1_rk), tomstates,tomgrids, tomvalfuncs,todayinfo, params)          
           vprime(ix) = (forderiv1-forderiv2)/(0.2_rk)                        
           euler(ix) = margut(ix) -  params%beta * vprime(ix)        
           call utility(points, values(ix), cons(ix), todayinfo, params, tomstates, tomgrids, tomvalfuncs)                      
        end do

        call getpaths(path_in, path_out)
        out_cons = trim(path_out) // 'cons.out'
        out_values = trim(path_out) // 'values.out'
        out_details = trim(path_out) // 'detailsofobject.out'
        out_leftoverA = trim(path_out) // 'leftoverA.out'
        out_valLeftOver = trim(path_out) // 'valLeftoverA.out'
        out_euler = trim(path_out) // 'euler.out'
        out_margut = trim(path_out) // 'margut.out'
        out_vprime = trim(path_out) // 'vprime.out'
        out_gridA0 = trim(path_out) // 'gridA0.out'
        out_gridA1 = trim(path_out) // 'gridA1.out'
        
        
        !Collect all the other info that I need
        otherinfo(1) = todayinfo%ixassnode
        otherinfo(2) = todayinfo%ixdcnode
        otherinfo(3) = todayinfo%ixpenpoint
        otherinfo(4) = todayinfo%ixhhcomp
        otherinfo(5) = todayinfo%ixage
        otherinfo(6) = todayinfo%ixhouspoint
        otherinfo(7) = todayinfo%ixar1node
        otherinfo(8) = todayinfo%leistoday
        otherinfo(9) = todayinfo%ixdcchoice
        otherinfo(10) = todayinfo%ixclaimchoice
        otherinfo(11) = b !Cash on hand        

        open (unit=101, file=out_cons, access='sequential', action='write')
        open (unit=102, file=out_values, access='sequential', action='write') 
        open (unit=103, file=out_details, access='sequential', action='write') 
        open (unit=104, file=out_leftoverA, access='sequential', action='write') 
        open (unit=105, file=out_valLeftOver, access='sequential', action='write') 
        open (unit=106, file=out_euler, access='sequential', action='write') 
        open (unit=107, file=out_margut, access='sequential', action='write') 
        open (unit=108, file=out_vprime, access='sequential', action='write') 
        open (unit=109, file=out_gridA0, access='sequential', action='write') 
        open (unit=110, file=out_gridA1, access='sequential', action='write') 

        write (101, '(300f20.3)') cons
        write (102, '(300f20.15)') values
        write (103, '(11f15.2)') otherinfo
        write (104, '(300f20.3)') leftoverA
        write (105, '(300f20.15)') valLeftOver 
        write (106, '(300f20.15)') euler 
        write (107, '(300f20.15)') margut 
        write (108, '(300f20.15)') vprime 
        write (109, '(300f20.3)') gridA0 
        write (110, '(300f20.3)') gridA1 
                 
                  
      end subroutine getobjectivefunc
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!        
        


! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

! Check stochastic discount factor from the simulations
      subroutine checksdfsim(points, sdf, licon, failmaxoversims, failaveoversims)
        implicit none

! Arguments
        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: sdf(points%numyears, points%sims)
        integer, intent (in) :: licon(points%numyears, points%sims)
        real (kind=rk), intent (out) :: failmaxoversims(4)
        real (kind=rk), intent (out) :: failaveoversims(4)

! For program
        real (kind=rk) :: failproptotal(4) 
! indexes
        integer :: ixtoday, ixsim
        integer :: countinplaytotal
        integer :: countinplayind
        integer :: failtotal(4)

        integer :: failind(4)
        real (kind=rk) :: failpropind(4)
        real (kind=rk) :: failpropallsims(4, points%sims)

        integer :: failindbyyear(points%numyears, 4)
        real (kind=rk) :: failpropbyyear(points%numyears, 4)


        failtotal(1) = 0
        failtotal(2) = 0
        failtotal(3) = 0
        failtotal(4) = 0

        countinplaytotal = 0 ! This is the number of stochastic discount factors we're testing (i.e. not liquidity
! constrained)
        do ixsim = 1, points%sims
          countinplayind = 0
          failind(1) = 0
          failind(2) = 0
          failind(3) = 0
          failind(4) = 0
          do ixtoday = points%numyears, 1, -1
            if (licon(ixtoday,ixsim).ne.1) then
              countinplaytotal = countinplaytotal + 1
              countinplayind = countinplayind + 1
              if ((sdf(ixtoday,ixsim).lt.0.99_rk) .or. (sdf(ixtoday,ixsim).gt.1.01_rk)) then
                failtotal(1) = failtotal(1) + 1
                failind(1) = failind(1) + 1
                if ((sdf(ixtoday,ixsim).lt.0.975_rk) .or. (sdf(ixtoday,ixsim).gt.1.025_rk)) then
                  failtotal(2) = failtotal(2) + 1
                  failind(2) = failind(2) + 1
                  if ((sdf(ixtoday,ixsim).lt.0.95_rk) .or. (sdf(ixtoday,ixsim).gt.1.05_rk)) then
                    failtotal(3) = failtotal(3) + 1
                    failind(3) = failind(3) + 1
                    if ((sdf(ixtoday,ixsim).lt.0.90_rk) .or. (sdf(ixtoday,ixsim).gt.1.1_rk)) then
                      failtotal(4) = failtotal(4) + 1
                      failind(4) = failind(4) + 1
                    end if
                  end if
                end if
              end if
            end if ! If not liquidity constrained
          end do ! ixtoday
          if (countinplayind.gt.0) then
            failpropind = real(failind, rk)/real(countinplayind, rk)
          else if (countinplayind.eq.0) then
            failpropind(1) = 0
            failpropind(2) = 0
            failpropind(3) = 0
            failpropind(4) = 0
          end if
          failpropallsims(:, ixsim) = failpropind
        end do ! ixsim

        if (countinplaytotal.ne.0) failproptotal = real(failtotal, rk)/real(countinplaytotal, rk)
        if (countinplaytotal.eq.0) failproptotal = 1.0_rk
        
        failmaxoversims = maxval(failpropallsims, 2)
        failaveoversims = sum(failpropallsims, 2)/real(points%sims, rk)

      end subroutine checksdfsim

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
! Get asset grids and cumulative earning grids

      subroutine getgrids(points, detincome, ar1shocks,  ratedum, assgrid, dcgrid, pengrid, housgrid)
        use globalvalues
        implicit none

        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: detincome(points%numyears)
        real (kind=rk), intent (in) :: ar1shocks(points%ar1, points%numyears)
        real (kind=rk), intent (in) :: ratedum
        real (kind=rk), intent (out) :: assgrid(points%ass, points%numyears+1)
        real (kind=rk), intent (out) :: dcgrid(points%dc, claimAge-19)
        real (kind=rk), intent (out) :: pengrid(points%pen)
        real (kind=rk), intent (out) :: housgrid(points%ass, (65-19):points%numyears)
        
! For programme
        real (kind=rk) :: maxincome(points%numyears+1)
        real (kind=rk) :: maxassets(points%numyears+1)
        real (kind=rk) :: maxdc(points%numyears+1)
        real (kind=rk) :: housgrid64(points%ass) ! one period
        real (kind=rk) :: lowerbounds(points%numyears+1)
        real (kind=rk) :: breaks1(points%numyears+1)
        real (kind=rk) :: breaks2(points%numyears+1)
        real (kind=rk) :: upperbounds(points%numyears+1)

        real (kind=rk) :: housShare
        real (kind=rk) :: mort, grossH, allHreturn 
        integer :: ixtoday, ixdcnode, ixassnode
        logical :: firstOne, secondOne
        type (typetodayinfo) :: todayinfoGrids
        
        
! First of all get maximum income in each year
        do ixtoday = 1, (points%numyears+1), 1
          if (ixtoday.le.points%numyears) then
            maxincome(ixtoday) = detincome(ixtoday)*ar1shocks(points%ar1, ixtoday)
          else
            maxincome(ixtoday) = 0._rk
          end if
        end do


!-------------------------------------!
! Get the asset grid
!-------------------------------------!

        do ixtoday= 1, points%numyears+1, 1
            call getnodes(assgrid(:, ixtoday), 0.0_rk, 2500000.0_rk, points%ass, 0.75_rk)              
        end do
        
        
!-------------------------------------!
! Get the DC grid
!-------------------------------------!

        do ixtoday= 1, claimAge-19, 1
             call getnodes(dcgrid(:, ixtoday), 0.0_rk, 2500000.0_rk, points%dc, 0.75_rk)
        end do
          

!-------------------------------------!
! Get the Pension grid
!-------------------------------------!
! Generate the retirement income grid
         pengrid = dcgrid(:, claimAge-19) * points%fairannuity(claimAge-19, 1) * points%oneminusdclumpsumprop

!-------------------------------------!        
! Get the housing wealth in retirement grid
!-------------------------------------!
        do ixassnode = 1, points%ass, 1
             housShare = 1.0_rk - getLiqShare(points, 64, 1.0_rk, assgrid(ixassnode, 64-19))    
             housgrid64(ixassnode) = assgrid(ixassnode, 64-19) * housShare
        end do
        

        
        do ixtoday= 65-19, points%numyears
              todayinfoGrids%ixage = ixtoday + 19 - 1
              call setTodayLeverageAndOver65(todayinfoGrids, points)
            do ixassnode = 1, points%ass, 1
              if (ixtoday.eq.(65-19)) then
                if (todayinfoGrids%leverage .lt. 0.0000000000000001_rk) then
                    mort = 0.0_rk
                else  
                    mort = housgrid64(ixassnode) / ( (1.0_rk/todayinfoGrids%leverage) - 1)   
                end if
                
                grossH = housgrid64(ixassnode) + mort  
                allHreturn =  grossH * (points%housCG) - points%mortR * mort                   
                housgrid(ixassnode, ixtoday) = housgrid64(ixassnode)  + allHreturn                        
              else
                if (todayinfoGrids%leverage .lt. 0.0000000000000001_rk) then
                    mort = 0.0_rk
                else  
                    mort = housgrid(ixassnode, ixtoday-1) / ( (1.0_rk/todayinfoGrids%leverage) - 1)   
                end if
                
                grossH = housgrid(ixassnode, ixtoday-1) + mort  
                allHreturn =  grossH * (points%housCG) - points%mortR * mort                   
                housgrid(ixassnode, ixtoday) = housgrid(ixassnode, ixtoday -1)  + allHreturn                                      
              end if
              
                
              
             
              
            end do            
        end do 
        
      end subroutine getgrids   



! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

      function getexpoverar1(points, valarray4d, shocktranvec, lowerar1nodeforint, upperar1nodeforint)
        implicit none
        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: valarray4d(points%ass, points%dc, points%ar1by4, 3)
        real (kind=rk), intent (in) :: shocktranvec(points%ar1by4)
        real (kind=rk) :: getexpoverar1(points%ass, points%dc, 3)
        integer :: lowerar1nodeforint, upperar1nodeforint
                
! For programme
        integer ixar1node, ixassnode,  ixdcnode, ixhhcomp

        do ixhhcomp = 1, 3, 1
              do ixdcnode = 1, points%dc, 1
                do ixassnode = 1, points%ass, 1
                  getexpoverar1(ixassnode, ixdcnode,  ixhhcomp) = 0.0_rk
                end do
              end do
        end do


        do ixar1node = lowerar1nodeforint, upperar1nodeforint, 1
          if (shocktranvec(ixar1node).gt.0.00_rk) then
            getexpoverar1 = getexpoverar1 + valarray4d(:, :,  ixar1node, :)*shocktranvec(ixar1node)
          end if
        end do


      end function getexpoverar1
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!



      subroutine getearningsarry(points, earnings, ar1shocks, allearnings)
        implicit none

        type (grids), intent (in) :: points
        real (kind=rk), intent (in) :: earnings(points%numyears)
        real (kind=rk), intent (in) :: ar1shocks(points%ar1by4, points%numyears)
        real (kind=rk), intent (out) :: allearnings(workChoices, points%ar1by4, points%numyears)


        integer :: ixtoday, ixar1node, ixage

        do ixtoday = 1, points%numyears, 1

            !Man given option of working, woman working
            do ixar1node = 1, points%ar1, 1
                allearnings(1, ixar1node, ixtoday) = 0.0_rk + points%womanearnprop * earnings(ixtoday)*ar1shocks(ixar1node, ixtoday)
                allearnings(2, ixar1node, ixtoday) = earnings(ixtoday)*ar1shocks(ixar1node, ixtoday) + points%womanearnprop * earnings(ixtoday)*ar1shocks(ixar1node, ixtoday)
            end do

            !Man not given option of working, woman working       
            do ixar1node = (points%ar1 + 1), points%ar1by2, 1
                allearnings(1, ixar1node, ixtoday) = 0.0_rk + points%womanearnprop * earnings(ixtoday)*ar1shocks(ixar1node, ixtoday)
                allearnings(2, ixar1node, ixtoday) = 0.0_rk + points%womanearnprop * earnings(ixtoday)*ar1shocks(ixar1node, ixtoday)
            end do

            !Man given option of working, woman not working       
            do ixar1node = points%ar1by2 + 1, points%ar1by3, 1
                allearnings(1, ixar1node, ixtoday) = 0.0_rk
                allearnings(2, ixar1node, ixtoday) = earnings(ixtoday)*ar1shocks(ixar1node, ixtoday)
            end do

            !Man not given option of working, woman not working              
            do ixar1node = (points%ar1by3 + 1), points%ar1by4, 1
                allearnings(1, ixar1node, ixtoday) = 0.0_rk          
                allearnings(2, ixar1node, ixtoday) = 0.0_rk
            end do
      
      
    end do
       

      end subroutine getearningsarry
! ---------------------------------------------------------------------------------------------------------!


! ---------------------------------------------------------------------------------------------------------!
      real (kind=rk) function netincome(grossincome, taxsys)
        implicit none

        real (kind=rk), intent (in) :: grossincome
        type (taxtype) :: taxsys

        if (grossincome.lt.taxsys%tfa) then
          netincome = grossincome
        else if (grossincome.lt.(taxsys%tfa+taxsys%higherthreshold)) then
          netincome = taxsys%tfa + (grossincome-taxsys%tfa)*(1-taxsys%basicrate)
        else
          netincome = taxsys%tfa + ((taxsys%higherthreshold-taxsys%tfa)*(1-taxsys%basicrate)) + &
            ((grossincome-taxsys%higherthreshold)*(1-taxsys%higherrate))
        end if

      end function netincome

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
      real (kind=rk) function netfamilyincome_new(grossincome, grossEarn, totInterest, interestForTax, taxsys, manshare, todayage)
        implicit none

        real (kind=rk), intent (in) :: grossincome ! This  includes interest
        real (kind=rk), intent (in) :: grossEarn
        real (kind=rk), intent (in) :: totInterest
        real (kind=rk), intent (in) :: interestForTax
        real (kind=rk), intent (in) :: manshare
        type (taxtype), intent(in) :: taxsys
        integer, intent(in) :: todayage
        real (kind=rk) :: netincomes(2)
        real (kind=rk) :: grossincomes(2), grossincomesForTax(2), grossearns(2)
        real (kind=rk) :: grossIncomeLessUnTaxedIncome
        real (kind=rk) :: mortgageRatio
        
        grossincomes(1) = manshare * grossincome
        grossincomes(2) = (1.0_rk - manshare) * grossincome
        
        if (taxsys%taxInterest) then
            grossIncomeLessUnTaxedIncome = grossincome - totInterest + interestForTax
        else
            grossIncomeLessUnTaxedIncome = grossincome - totInterest 
        end if
                
        grossincomesForTax(1) =  manshare * grossIncomeLessUnTaxedIncome
        grossincomesForTax(2) =  (1.0_rk - manshare) * grossIncomeLessUnTaxedIncome

        grossearns(1) =  manshare * grossEarn
        grossearns(2) =  (1.0_rk - manshare) * grossEarn


        netincomes(1) = grossincomes(1) - getinctax(grossincomesForTax(1), todayage, taxsys) - getNI(grossearns(1), taxsys, todayage)
        netincomes(2) = grossincomes(2) - getinctax(grossincomesForTax(2), todayage, taxsys) - getNI(grossearns(2), taxsys, todayage)

        netfamilyincome_new =  netincomes(1) +  netincomes(2)
        
        if ((whichModel.eq.3).and.(todayage.lt.65)) then !This isSee Appendix B
            mortgageRatio = 0.2827866_rk - 0.0021787_rk * todayage - 0.0000204_rk * (todayage*todayage)
            netfamilyincome_new = netfamilyincome_new * (1 - mortgageRatio)
        end if
        
        
      end function netfamilyincome_new

! ---------------------------------------------------------------------------------------------------------!
    real (kind=rk) function getinctax(grossincome, todayage, taxsys)
        implicit none

        real (kind=rk), intent (in) :: grossincome
        integer, intent(in) :: todayage
        type (taxtype), intent(in) :: taxsys

        real (kind=rk) :: taxableinc

        if ((todayage.ge.0).and.(todayage.le.64)) then
                taxableinc = grossincome  - taxsys%tfa
        else if ((todayage.ge.65).and.(todayage.le.74)) then
                taxableinc = grossincome  - taxsys%tfa6574
        else if (todayage.ge.75) then
                taxableinc = grossincome  - taxsys%tfa75plus
        else
                write(*,*) 'error in getinctax - todayage is not in the permitted bounds'
                stop                
        end if    
    
      
       if (taxableinc.lt.0) then
           getinctax = 0.0_rk
        else if (taxableinc.lt.taxsys%startinglimit) then
            getinctax = taxableinc * taxsys%startingrate
        else if (taxableinc.lt.(taxsys%higherthreshold)) then
            getinctax = taxsys%startinglimit * taxsys%startingrate + &
                        (taxableinc - taxsys%startinglimit) * taxsys%basicrate  
        else
            getinctax = taxsys%startinglimit * taxsys%startingrate + &
                        (taxsys%higherthreshold - taxsys%startinglimit) * taxsys%basicrate  + &
                        (taxableinc - taxsys%higherthreshold) * taxsys%higherrate
        end if
        

    end function getinctax
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
    real (kind=rk) function getNI(grossearn, taxsys, todayage)
        implicit none

        real (kind=rk), intent (in) :: grossearn
        type (taxtype), intent(in) :: taxsys
        integer, intent(in) :: todayage

        
        if ((grossearn.lt.taxsys%lel).or.(todayage.ge.taxsys%statepenage)) then
           getNI = 0.0_rk
        else if (grossearn.lt.(taxsys%uel)) then
            getNI = (grossearn-taxsys%lel)*taxsys%NIlower
        else
            getNI = (taxsys%uel-taxsys%lel)*(taxsys%NIlower) + &
                        (grossearn-taxsys%uel)*(taxsys%NIhigher)
        end if
        
        
    end function getNI
! ---------------------------------------------------------------------------------------------------------!

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
      
      
      
!A function that gives the summary statistics of the corss-sectional distributions

      subroutine sumstats(series, years, numpeople, mean, sdev, skew, kurt, min, max, weights, logvals)
        implicit none

!Arguments
        integer, intent (in) :: years
        integer, intent (in) :: numpeople
        real (kind=rk), intent (in) :: series(years, numpeople)
        real (kind=rk), intent (out), optional :: mean(years)
        real (kind=rk), intent (out), optional :: sdev(years)
        real (kind=rk), intent (out), optional :: skew(years)
        real (kind=rk), intent (out), optional :: kurt(years)
        real (kind=rk), intent (out), optional :: min(years)
        real (kind=rk), intent (out), optional :: max(years)
        real (kind=rk), intent (in), optional :: weights(years, numpeople)
        logical, intent (in), optional :: logvals

!Indexes
        integer :: ixyear, ixperson

!FOr programme
        integer :: haveweights
        integer :: ifail
        real (kind=rk) :: sumweights(years)
        real (kind=rk) :: xs_series(numpeople)
        real (kind=rk) :: xs_weights(numpeople)
        real (kind=rk) :: seriesforprog(years, numpeople)

!Given that I am allowing a lot of optional arguments in the case of arguments that are not optional for the
!NAG routine I have to create duplicates that exist for the nag routine
        real (kind=rk) :: weightsfornag(years, numpeople)
        real (kind=rk) :: meanfornag(years)
        real (kind=rk) :: sdevfornag(years)
        real (kind=rk) :: skewfornag(years)
        real (kind=rk) :: kurtfornag(years)
        real (kind=rk) :: minfornag(years)
        real (kind=rk) :: maxfornag(years)
	    logical :: dologs
	    real (kind=rk) :: rcomm(20)
        
        
        haveweights = 1
        weightsfornag = 1

        if (present(weights)) then
          weightsfornag = weights
        end if

        if (present(logvals)) then !These have to be split into two conditions as logvals doesn't exist 
         if (logvals) then 
         dologs = .true.
         else
         dologs = .false.
         end if
         else
         dologs = .false.
        end if
         

        if (dologs) then
!The way I deal with zero or negative values is that I take the summary statistics ignoring these values
!Before taking the log, I replace these values with a positive number, to avoid an error
!But I set weights to be zero for these observations

          do ixperson = 1, numpeople, 1
            do ixyear = 1, years, 1

              if (series(ixyear,ixperson).le.0) then
                seriesforprog(ixyear, ixperson) = 0.0_rk
                weightsfornag(ixyear, ixperson) = 0.0_rk
              else
                seriesforprog(ixyear, ixperson) = log(series(ixyear,ixperson))
              end if

            end do
          end do
        else
          seriesforprog = series
        end if

!Want to get cross-sectional summary statistics
        do ixyear = 1, years, 1
          xs_series = seriesforprog(ixyear, :)
          xs_weights = weightsfornag(ixyear, :)
          if (sum(xs_weights).le.0) then
            meanfornag(ixyear) = -99999
            sdevfornag(ixyear) = -99999
            skewfornag(ixyear) = -99999
            kurtfornag(ixyear) = -99999
            minfornag(ixyear) = -99999
            maxfornag(ixyear) = -99999
          else
            haveweights = 1
            ifail = 1
            !--------------------------------------!
            ! For NAG Mark 26 - OUT for  NAG Mark 24 - IN
            !!
                !call g01aaf(numpeople, xs_series, haveweights, xs_weights, meanfornag(ixyear), sdevfornag(ixyear), &
                !  skewfornag(ixyear), kurtfornag(ixyear), minfornag(ixyear), maxfornag(ixyear), sumweights, ifail)
            !!
            !--------------------------------------!
                
                
            !----------------------------------------------!
            ! For NAG Mark 26 - IN for  NAG Mark 24 - OUT
            !!    
                if (numpeople.eq.1) then
                        meanfornag(ixyear) = xs_series(1)
                else
                     call g01atf(numpeople, xs_series, haveweights,0,xs_weights, meanfornag(ixyear), sdevfornag(ixyear), &
                             skewfornag(ixyear), kurtfornag(ixyear), minfornag(ixyear), maxfornag(ixyear),rcomm,ifail)
                
                if ((ifail.ne.2).and.(ifail.ne.0).and.(ifail.ne.72).and.(ifail.ne.53)) then
                   write(*,*) 'Error in sumstats - NAG routine reporting a failure - ifail', ifail            
                else if (ifail.eq.2) then !Only one valid case
                 sdevfornag(ixyear)= -99999
                 skewfornag(ixyear)= -99999
                 kurtfornag(ixyear) = -99999
                end if 
                end if !if (numpeople.eq.1) then
            !!
            !----------------------------------------------!
            
            end if
        end do

        if (present(mean)) mean = meanfornag
        if (present(sdev)) sdev = sdevfornag
        if (present(skew)) skew = skewfornag
        if (present(kurt)) kurt = kurtfornag
        if (present(min)) min = minfornag
        if (present(max)) max = maxfornag

      end subroutine sumstats
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

      subroutine getdcquadweights(points, weights, abscis)
        implicit none

        type (grids), intent (in) :: points
        real (kind=rk), intent (out) :: weights(points%dcquad%dim), abscis(points%dcquad%dim)
        ! For NAG MARK 26 - OUT  FOR NAG MARX 24 - IN
        !external d01baw !pre mark 24
        real (kind=rk) :: a, b
        integer :: itype, ifail
        real (kind=rk), parameter :: pi = 3.14159265

        real (kind=rk) :: test
        integer :: ixtest

        if (points%dcquad%dim.gt.1) then
          a = points%dcmeanret
          b = 1/(2*points%dcstdev*points%dcstdev)

          ifail = 0
        
           !-------------------------------------------------------------------------------!
           ! For NAG MARK 26 - OUT  NAG MARK 24 - IN
           !!
              !itype = 0          
               ! call d01bbf(d01baw, a, b, itype, points%dcquad%dim, weights, abscis, ifail)
           !!
           !-------------------------------------------------------------------------------!
              
              
           !-------------------------------------------------------------------------------!
           ! For NAG MARK 26 - IN  NAG MARK 24 - OUT
           !!
              call d01tbf(4,a,b,points%dcquad%dim,weights,abscis,ifail)
           !!
           !-------------------------------------------------------------------------------!
              
          weights = weights*1/(points%dcstdev*sqrt(2*pi))
        else if (points%dcquad%dim.eq.1) then
          weights(1) = 1.0_rk
          abscis(1) = points%dcmeanret
        end if

        test = 0.0_rk
        do ixtest = 1, points%dcquad%dim, 1
          test = test + weights(ixtest)
        end do

        if (abs(test-1).gt.0.001_rk) then
          write (*, *) 'Error in getdcquadweights'
          stop
        end if
      end subroutine getdcquadweights
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
      subroutine printstats(alltypstats)
        use types !Includes globalvalues which I need for numtypes

        implicit none

        type (seriesstats), intent (in) :: alltypstats(numtypes)
        character (80) :: path_in
        character (80) :: path_out
        character (80) :: out_mean
        character (80) :: out_sdev
        character (80) :: out_skew
        character (80) :: out_kurt
        character (80) :: out_min
        character (80) :: out_max
        character (80) :: filestub
        real (kind=rk) :: forprinting_mean(numtypes, numyears)
        real (kind=rk) :: forprinting_sdev(numtypes, numyears)
        real (kind=rk) :: forprinting_skew(numtypes, numyears)
        real (kind=rk) :: forprinting_kurt(numtypes, numyears)
        real (kind=rk) :: forprinting_min(numtypes, numyears)
        real (kind=rk) :: forprinting_max(numtypes, numyears)
        character (10) :: tempformat_numtypecols
        character (20) :: format_numtypecols
        integer :: ixtype

! Opening files for output
        call getpaths(path_in, path_out)
        write (tempformat_numtypecols, '(I10)') numtypes
        format_numtypecols = '(' // trim(adjustl(tempformat_numtypecols)) // 'f15.5' // ')'

!-------------------------------------!   
!Print the stats for all types    
!-------------------------------------!   
!----!
!Consumption first
!----!
!Levels
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%con%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%con%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%con%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%con%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%con%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%con%max
        end do

        filestub = 'con'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!Levels of equivilised consumption
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%eqcon%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%eqcon%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%eqcon%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%eqcon%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%eqcon%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%eqcon%max
        end do

        filestub = 'eqcon'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

        

!----!
!Assets 
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%ass%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%ass%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%ass%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%ass%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%ass%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%ass%max
        end do

        filestub = 'ass'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)


!----!
!'Total' Assets - DC plus cash
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%totass%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%totass%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%totass%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%totass%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%totass%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%totass%max
        end do

        filestub = 'totass'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)


!----!
!Earnings 
!----!
!Levels 
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%earn%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%earn%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%earn%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%earn%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%earn%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%earn%max
        end do

        filestub = 'earn'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)


!----!
!Income 
!----!
!Levels
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%inc%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%inc%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%inc%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%inc%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%inc%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%inc%max
        end do

        filestub = 'inc'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!Gross  income
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%grossinc%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%grossinc%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%grossinc%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%grossinc%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%grossinc%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%grossinc%max
        end do

        filestub = 'grossinc'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!State pension
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%statepen%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%statepen%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%statepen%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%statepen%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%statepen%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%statepen%max
        end do

        filestub = 'statepen'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!DB
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%db%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%db%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%db%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%db%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%db%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%db%max
        end do

        filestub = 'db'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!DC
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%dc%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%dc%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%dc%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%dc%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%dc%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%dc%max
        end do

        filestub = 'dc'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)        
        
!----!
!Guarantee Credit
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%guarcred%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%guarcred%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%guarcred%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%guarcred%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%guarcred%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%guarcred%max
        end do

        filestub = 'guarcred'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
          
!----!
!Saving Credit
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%savcred%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%savcred%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%savcred%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%savcred%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%savcred%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%savcred%max
        end do

        filestub = 'savcred'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
          

!----!
!Dcflowval
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%dcflowval%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%dcflowval%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%dcflowval%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%dcflowval%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%dcflowval%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%dcflowval%max
        end do

        filestub = 'dcflowval'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)


!----!
!dcstockval
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%dcstockval%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%dcstockval%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%dcstockval%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%dcstockval%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%dcstockval%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%dcstockval%max
        end do

        filestub = 'dcstockval'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)


!----!
!Licon
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%licon%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%licon%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%licon%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%licon%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%licon%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%licon%max
        end do

        filestub = 'licon'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!Unemployment
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%unemp%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%unemp%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%unemp%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%unemp%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%unemp%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%unemp%max
        end do

        filestub = 'unemp'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!Utility
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%utility%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%utility%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%utility%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%utility%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%utility%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%utility%max
        end do

        filestub = 'utility'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!assStart
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%assStart%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%assStart%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%assStart%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%assStart%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%assStart%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%assStart%max
        end do

        filestub = 'assStart'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)


!----!
!cashPaths
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%cashPaths%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%cashPaths%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%cashPaths%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%cashPaths%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%cashPaths%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%cashPaths%max
        end do

        filestub = 'cashPaths'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!housingPaths
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%housingPaths%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%housingPaths%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%housingPaths%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%housingPaths%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%housingPaths%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%housingPaths%max
        end do

        filestub = 'housingPaths'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

        
!----!
!SDF
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%sdf%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%sdf%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%sdf%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%sdf%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%sdf%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%sdf%max
        end do

        filestub = 'sdf'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

        
!----!
!licon
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%licon%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%licon%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%licon%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%licon%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%licon%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%licon%max
        end do

        filestub = 'licon'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

!----!
!Decile Paths
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%shockDec%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%shockDec%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%shockDec%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%shockDec%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%shockDec%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%shockDec%max
        end do

        filestub = 'shockDec'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
          
!----!
!CashInterest
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%cashInterest%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%cashInterest%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%cashInterest%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%cashInterest%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%cashInterest%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%cashInterest%max
        end do

        filestub = 'cashInterest'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

        
!----!
!CashInterest
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%cashInterest%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%cashInterest%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%cashInterest%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%cashInterest%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%cashInterest%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%cashInterest%max
        end do

        filestub = 'cashInterest'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)


!----!
!Housing Capital Gain
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%housingCG%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%housingCG%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%housingCG%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%housingCG%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%housingCG%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%housingCG%max
        end do

        filestub = 'housingCG'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)


!----!
!Housing Yield
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%housingYield%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%housingYield%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%housingYield%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%housingYield%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%housingYield%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%housingYield%max
        end do

        filestub = 'housingYield'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)

                

!----!
!Mortgage
!----!
        do ixtype = 1, numtypes
          forprinting_mean(ixtype, :) = alltypstats(ixtype)%mortgage%mean
          forprinting_sdev(ixtype, :) = alltypstats(ixtype)%mortgage%sdev
          forprinting_skew(ixtype, :) = alltypstats(ixtype)%mortgage%skew
          forprinting_kurt(ixtype, :) = alltypstats(ixtype)%mortgage%kurt
          forprinting_min(ixtype, :) = alltypstats(ixtype)%mortgage%min
          forprinting_max(ixtype, :) = alltypstats(ixtype)%mortgage%max
        end do

        filestub = 'mortgage'
        call concat(filestub, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
        call dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, forprinting_min, &
          forprinting_max, out_mean, out_sdev, out_skew, out_kurt, out_min, out_max)
   
      contains
! ---------------------------------------------------------------------------------------------------------!

        subroutine dotheprinting(forprinting_mean, forprinting_sdev, forprinting_skew, forprinting_kurt, &
            forprinting_min, forprinting_max, dum1out_mean, dum1out_sdev, dum1out_skew, dum1out_kurt, dum1out_min, &
            dum1out_max)
          implicit none
          real (kind=rk), intent (in), dimension (numtypes, numyears) :: forprinting_mean, forprinting_sdev, &
            forprinting_skew, forprinting_kurt, forprinting_min, forprinting_max
          character (80), intent (in) :: dum1out_mean, dum1out_sdev, dum1out_skew, dum1out_kurt, dum1out_min, &
            dum1out_max
          integer :: requiredl

          inquire (iolength=requiredl) forprinting_mean
          open (unit=300, file=dum1out_mean, recl=requiredl, action='write')
          write (300, trim(format_numtypecols)) forprinting_mean
          close (300)

        end subroutine dotheprinting
! ---------------------------------------------------------------------------------------------------------!

        subroutine concat(dumfilestub, dumout_mean, dumout_sdev, dumout_skew, dumout_kurt, dumout_min, dumout_max)
          implicit none

          character (80), intent (in) :: dumfilestub
          character (80), intent (out) :: dumout_mean
          character (80), intent (out) :: dumout_sdev
          character (80), intent (out) :: dumout_skew
          character (80), intent (out) :: dumout_kurt
          character (80), intent (out) :: dumout_min
          character (80), intent (out) :: dumout_max

          dumout_mean = trim(path_out) // trim(dumfilestub) // 'mean.out'
         dumout_sdev = trim(path_out) // trim(dumfilestub) // 'sdev.out'
          dumout_skew = trim(path_out) // trim(dumfilestub) // 'skew.out'
          dumout_kurt = trim(path_out) // trim(dumfilestub) // 'kurt.out'
          dumout_min = trim(path_out) // trim(dumfilestub) // 'min.out'
          dumout_max = trim(path_out) // trim(dumfilestub) // 'max.out'


        end subroutine concat
! ---------------------------------------------------------------------------------------------------------!

      end subroutine printstats
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
      subroutine printsimdetail(points, ixtype, sdfsimeveryone, cpatheveryone, apatheveryone, earningseveryone, incomeseveryone, &
          dcfloweveryone, dcstockeveryone, totasseveryone,lpathseverone, rpathseveryone, liconeveryone, allar1locpaths, unemp, &
          allar1val,dcinc,dbinc,grossinc,statepeninc,pcinc, alive)

        use globalvalues !This is ONLY to allow getpaths to run

        implicit none
        type (grids), intent (in) :: points
        integer, intent (in) :: ixtype
        real (kind=rk), intent (in) :: sdfsimeveryone(points%numyears, points%sims)
        real (kind=rk), intent (in) :: cpatheveryone(points%numyears, points%sims)
        real (kind=rk), intent (in) :: apatheveryone(points%numyears, points%sims)
        real (kind=rk), intent (in) :: earningseveryone(points%numyears, points%sims)
        real (kind=rk), intent (in) :: incomeseveryone(points%numyears, points%sims)
        real (kind=rk), intent (in) :: dcfloweveryone(points%numyears, points%sims)
        real (kind=rk), intent (in) :: dcstockeveryone(points%numyears, points%sims)
        real (kind=rk), intent (in) :: totasseveryone(points%numyears, points%sims)
        integer, intent (in) :: lpathseverone(points%numyears, points%sims)
        integer, intent (in) :: rpathseveryone(points%numyears, points%sims)
        integer, intent (in) :: liconeveryone(points%numyears, points%sims)
        integer, intent (in) :: allar1locpaths(points%numyears, points%sims)
        integer, intent (in) :: unemp(points%numyears, points%sims)
        real (kind=rk), intent (in) :: allar1val(points%numyears, points%sims)
        real (kind=rk), intent (in) :: dcinc(points%numyears, points%sims)
        real (kind=rk), intent (in) :: dbinc(points%numyears, points%sims)
        real (kind=rk), intent (in) :: grossinc(points%numyears, points%sims)
        real (kind=rk), intent (in) :: statepeninc(points%numyears, points%sims)
        real (kind=rk), intent (in) :: pcinc(points%numyears, points%sims)
        real (kind=rk), intent (in) :: alive(points%numyears, points%sims)
        
        character (10) :: tempformat_numpeepcols
        character (20) :: format_numpeepcols
        character (20) :: format_numpeepcols_int
        character (80) :: path_in
        character (80) :: path_out
        character (80) :: out_sdfsim
        character (80) :: out_consim
        character (80) :: out_asssim
        character (80) :: out_earnsim
        character (80) :: out_incsim
        character (80) :: out_dcflowsim
        character (80) :: out_dcstocksim
        character (80) :: out_totasssim
        character (80) :: out_leissim
        character (80) :: out_rsim
        character (80) :: out_liconsim
        character (80) :: out_ar1locsim
        character (80) :: out_ar1valsim
        character (80) :: out_unempsim
        character (80) :: out_dcinc
        character (80) :: out_dbinc
        character (80) :: out_grossinc
        character (80) :: out_statepeninc
        character (80) :: out_pcinc
        character (80) :: out_alive
        character (10) :: charixtype
        
        integer :: requiredl
        
! Opening files for output
        call getpaths(path_in, path_out)
        
        write(charixtype, '(I10)') ixtype
             
        out_sdfsim = trim(path_out) //trim(adjustl(charixtype))// 'sdfsim.out'
        out_consim = trim(path_out) //trim(adjustl(charixtype))// 'consim.out'
        out_asssim = trim(path_out) //trim(adjustl(charixtype))// 'asssim.out'
        out_earnsim = trim(path_out) //trim(adjustl(charixtype))// 'earnsim.out'
        out_incsim = trim(path_out) //trim(adjustl(charixtype))// 'incsim.out'
        out_dcflowsim = trim(path_out) //trim(adjustl(charixtype))// 'dcflowsim.out'
        out_dcstocksim = trim(path_out) //trim(adjustl(charixtype))// 'dcstocksim.out'
        out_totasssim = trim(path_out) //trim(adjustl(charixtype))// 'totasssim.out'
        out_leissim = trim(path_out) //trim(adjustl(charixtype))// 'leissim.out'
        out_rsim = trim(path_out) //trim(adjustl(charixtype))// 'rsim.out'
        out_liconsim = trim(path_out) //trim(adjustl(charixtype))// 'liconsim.out'
        out_ar1locsim = trim(path_out) //trim(adjustl(charixtype))// 'ar1locsim.out'
        out_unempsim = trim(path_out) //trim(adjustl(charixtype))// 'unempsim.out'
        out_ar1valsim = trim(path_out) //trim(adjustl(charixtype))// 'ar1valsim.out'
        out_dcinc = trim(path_out) //trim(adjustl(charixtype))// 'dcincsim.out'
        out_dbinc = trim(path_out) //trim(adjustl(charixtype))// 'dbincsim.out'
        out_grossinc = trim(path_out) //trim(adjustl(charixtype))// 'grossinc.out'
        out_statepeninc = trim(path_out) //trim(adjustl(charixtype))// 'statepensim.out'
        out_pcinc = trim(path_out) //trim(adjustl(charixtype))// 'pcinc.out'
        out_alive= trim(path_out) //trim(adjustl(charixtype))// 'alive.out'
        
        inquire (iolength=requiredl) transpose(sdfsimeveryone)
        open (unit=200, file=out_sdfsim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(cpatheveryone)
        open (unit=201, file=out_consim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(apatheveryone)
        open (unit=202, file=out_asssim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(incomeseveryone)
        open (unit=203, file=out_incsim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(lpathseverone)
        open (unit=204, file=out_leissim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(rpathseveryone)
        open (unit=205, file=out_rsim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(liconeveryone)
        open (unit=206, file=out_liconsim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(dcfloweveryone)
        open (unit=207, file=out_dcflowsim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(dcstockeveryone)
        open (unit=208, file=out_dcstocksim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(allar1locpaths)
        open (unit=209, file=out_ar1locsim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(earningseveryone)
        open (unit=210, file=out_earnsim, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(unemp)
        open (unit=211, file=out_unempsim, recl=requiredl, action='write')        
 
        inquire (iolength=requiredl) transpose(allar1val)
        open (unit=212, file=out_ar1valsim, recl=requiredl, action='write')        
        
        inquire (iolength=requiredl) transpose(totasseveryone)
        open (unit=213, file=out_totasssim, recl=requiredl, action='write')        

        inquire (iolength=requiredl) transpose(dcinc)
        open (unit=214, file=out_dcinc, recl=requiredl, action='write')

        inquire (iolength=requiredl) transpose(dbinc)
        open (unit=215, file=out_dbinc, recl=requiredl, action='write')        
 
        inquire (iolength=requiredl) transpose(grossinc)
        open (unit=216, file=out_grossinc, recl=requiredl, action='write')        
        
        inquire (iolength=requiredl) transpose(statepeninc)
        open (unit=217, file=out_statepeninc, recl=requiredl, action='write')        

        inquire (iolength=requiredl) transpose(pcinc)
        open (unit=218, file=out_pcinc, recl=requiredl, action='write')   
   
        inquire (iolength=requiredl) transpose(alive)
        open (unit=219, file=out_alive, recl=requiredl, action='write')   
   
! In printing it I have to tell format how many columns there are.
! If there are 10 columns and the format of each entry is f15.15, the format I give write needs to be 10f15.5.
! In the first row I want the to print time period 1 for each individual. So I want to read across the first
! row of sdfsimeveryone (numyears, howmanysims). But write(*,*) reads down each columns first. So I need to take
! the tranpose
! so the first column of the matrix is in fact the first period for everyone rather than all periods for person 1

! Finally, I need to generate a string that is 'x'f15.5 where 'x' is the number of periods. I do this below
        write (tempformat_numpeepcols, '(I10)') points%sims
        format_numpeepcols = '(' // trim(adjustl(tempformat_numpeepcols)) // 'f15.5' // ')'
        format_numpeepcols_int = '(' // trim(adjustl(tempformat_numpeepcols)) // 'I5' // ')'
        write (200, trim(format_numpeepcols)) transpose(sdfsimeveryone)
        write (201, trim(format_numpeepcols)) transpose(cpatheveryone)
        write (202, trim(format_numpeepcols)) transpose(apatheveryone)
        write (203, trim(format_numpeepcols)) transpose(incomeseveryone)
        write (204, trim(format_numpeepcols_int)) transpose(lpathseverone)
        write (205, trim(format_numpeepcols_int)) transpose(rpathseveryone)
        write (206, trim(format_numpeepcols_int)) transpose(liconeveryone)
        write (207, trim(format_numpeepcols)) transpose(dcfloweveryone)
        write (208, trim(format_numpeepcols)) transpose(dcstockeveryone)
        write (209, trim(format_numpeepcols_int)) transpose(allar1locpaths)
        write (210, trim(format_numpeepcols)) transpose(earningseveryone)
        write (211, trim(format_numpeepcols_int)) transpose(unemp)
        write (212, trim(format_numpeepcols)) transpose(allar1val)
        write (213, trim(format_numpeepcols)) transpose(totasseveryone)
        write (214, trim(format_numpeepcols)) transpose(dcinc)        
        write (215, trim(format_numpeepcols)) transpose(dbinc)
        write (216, trim(format_numpeepcols)) transpose(grossinc)
        write (217, trim(format_numpeepcols)) transpose(statepeninc)
        write (218, trim(format_numpeepcols)) transpose(pcinc)
        write (219, trim(format_numpeepcols)) transpose(alive)
        
      end subroutine printsimdetail

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
subroutine getmeanperminc(points, ar1shocksnoue2, detincome, meanperminc)
  implicit none
  type (grids), intent (in) :: points
  real (kind=rk), intent(in) :: ar1shocksnoue2(points%ar1,points%numyears)
  real (kind=rk), intent (in) :: detincome(points%numyears)
  real (kind=rk), intent (out) ::  meanperminc(points%numyears)    
  integer :: ix
  
  do ix = 1, points%numyears
   meanperminc(ix) = (sum(ar1shocksnoue2(:,ix))/real(size(ar1shocksnoue2(:,ix)), rk)) * detincome(ix)
  end do 
  
end subroutine getmeanperminc
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
subroutine printmeanperminc(points, meanperminc)
    
    use globalvalues !This is to allow getpaths to run and to access numtypes
    
    implicit none

    type (grids), intent (in) :: points
    real (kind=rk), intent (in) :: meanperminc(points%numyears, numtypes)
   
    character (80) :: path_in
    character (80) :: path_out
    character (80) :: out_meanperminc
    integer :: requiredl
    character (10) :: tempformat_numtypecols
    character (20) :: format_numtypecols   
   
        
    ! Opening files for output
    call getpaths(path_in, path_out)
     
    out_meanperminc = trim(path_out) // 'meanperminc.out'

    write (tempformat_numtypecols, '(I10)') numtypes
    format_numtypecols = '(' // trim(adjustl(tempformat_numtypecols)) // 'f15.5' // ')'
 
    inquire (iolength=requiredl) transpose(meanperminc)
    open (unit=300, file=out_meanperminc, recl=requiredl, action='write')  
    write (300, trim(format_numtypecols)) transpose(meanperminc)
    close (300)
    
end subroutine printmeanperminc
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
subroutine printvector(dim, vecToPrint, fileName)
    !Prints a generic vetor
    
    use globalvalues !This is to allow getpaths to run and to access numtypes
    
    implicit none
    
    integer, intent(in) :: dim
    real (kind=rk), intent(in) :: vecToPrint(dim)
    character*(*), intent(in) :: fileName
    
    character (80) :: path_in
    character (80) :: path_out
    character (80) :: out
    integer :: requiredl
    
    character (10) :: tempformat_numtypecols
    character (20) :: format_numtypecols   
           
    ! Opening files for output
    call getpaths(path_in, path_out)   
      
    out = trim(path_out) // fileName

    format_numtypecols = '(' // trim(adjustl(tempformat_numtypecols)) // 'f15.5' // ')'
 
    inquire (iolength=requiredl) vecToPrint
    open (unit=300, file=out, action='write')  
    write(300, '(f15.5)') vecToPrint
    close (300)
    
end subroutine printvector
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
subroutine printannuityrates(points)
    
    use globalvalues !This is to allow getpaths to run and to access numtypes
    
    implicit none

    type (grids), intent (in) :: points
    
    character (80) :: path_in
    character (80) :: path_out
    character (80) :: out_annuityrate
    integer :: requiredl
    character (10) :: tempformat_threecol
    character (20) :: format_threecol   
   
        
    ! Opening files for output
    call getpaths(path_in, path_out)
     
    out_annuityrate = trim(path_out) // 'annuityrates.out'

    write (tempformat_threecol, '(I10)') 3
    format_threecol = '(' // trim(adjustl(tempformat_threecol)) // 'f15.5' // ')'
 
    inquire (iolength=requiredl) points%fairannuity
    open (unit=900, file=out_annuityrate, recl=requiredl, action='write')        
    write (900, trim(format_threecol)) transpose(points%fairannuity(1:(points%numyears-1), :))
    close (900)
    
end subroutine printannuityrates
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
subroutine setparamsthisyear(numyears,numeqkidstoday, ixtoday, todayage, params)
  implicit none
  
  integer, intent(in) :: numyears
  real (kind=rk), intent(in) :: numeqkidstoday
  integer, intent(in) :: ixtoday
  integer, intent(in) :: todayage
  type (utilityparams), intent(inout) :: params
 
  !For program
  real (kind=rk) :: hheqsize(3)
 
 !Household equivalent size in each of the three composition states
    hheqsize(1) = 1.0_rk + numeqkidstoday
    hheqsize(2) = 0.67_rk + numeqkidstoday
    hheqsize(3) = 0.67_rk + numeqkidstoday     
    
    
    params%equivscaleinvvec(1) = 1.0_rk/hheqsize(1)
    params%equivscaleinvvec(2) = 1.0_rk/hheqsize(2)
    params%equivscaleinvvec(3) = 1.0_rk/hheqsize(3) 
  
end subroutine setparamsthisyear
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!


         
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
real (kind=rk) function getexpoverdc(points, tomgrids,valFuncForDCInt,dcstockval,dcsaveval,assval, ixhhcomp2)
  implicit none
    type (grids), intent (in) :: points
    type (typetomgrids), intent (in) :: tomgrids       
    real (kind=rk), intent (in) :: valFuncForDCInt(points%ass, points%dc)
    real (kind=rk), intent(in) :: dcstockval
    real (kind=rk), intent(in) :: dcsaveval
    real (kind=rk), intent(in) :: assval
    integer, intent(in) :: ixhhcomp2
    
    !For programme
    integer :: ixquad
    real (kind=rk) :: nextperioddc
    real (kind=rk) :: conttocontvalue
    

    
    getexpoverdc = 0.0_rk
      do ixquad = 1, points%dcquad%dim, 1
          nextperioddc = (1+points%dcquad%abs(ixquad))*(dcstockval + dcsaveval) 
          
             if (nextperioddc .gt. tomgrids%dc(points%dc)) then
                    nextperioddc =  tomgrids%dc(points%dc) + (nextperioddc/tomgrids%dc(points%dc)) * 0.0001_rk
             end if
          
            call linearinterp2_fast(tomgrids%ass, tomgrids%dc, points%ass, points%dc, assval, nextperioddc, &
              conttocontvalue, valFuncForDCInt)
            
          getexpoverdc = getexpoverdc + (conttocontvalue*points%dcquad%weigh(ixquad))
      end do
    
end function getexpoverdc    
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

       subroutine get3waysurvivalprob(numyears, survprobsman, survprobswoman, usesurvprobs, survprobscouple)
         implicit none
         integer :: numyears
         real (kind=rk), intent(inout) :: survprobsman(numyears)
         real (kind=rk), intent(inout) :: survprobswoman(numyears)
         logical, intent(in) :: usesurvprobs
         real (kind=rk), intent(out):: survprobscouple(3, 4, numyears)
         
         integer :: ixyear 
         
         
        if (.not.(usesurvprobs)) then ! Could move this into get3waysurvivalprob
            survprobsman = 1.0_rk
            survprobswoman = 1.0_rk
            survprobsman(numyears) = 0.0_rk
            survprobswoman(numyears) = 0.0_rk

        end if
         
         
         do ixyear = 1, numyears, 1
             !Probabilities of transition from both alive to other states (including death)
             survprobscouple(1, 1, ixyear) = survprobsman(ixyear) * survprobswoman(ixyear)
             survprobscouple(1, 2, ixyear) = survprobsman(ixyear) * (1.0_rk - survprobswoman(ixyear))
             survprobscouple(1, 3, ixyear) = (1.0_rk - survprobsman(ixyear)) * survprobswoman(ixyear)
             survprobscouple(1, 4, ixyear) = 1.0_rk - survprobscouple(1, 1, ixyear) - survprobscouple(1, 2, ixyear) - survprobscouple(1, 3, ixyear) 
             
             !Probabilities of transition from just man alive to other states (including death)
             survprobscouple(2, 1, ixyear) = 0.0_rk
             survprobscouple(2, 2, ixyear) = survprobsman(ixyear) 
             survprobscouple(2, 3, ixyear) = 0.0_rk
             survprobscouple(2, 4, ixyear) = 1.0_rk - survprobscouple(2, 1, ixyear) - survprobscouple(2, 2, ixyear) - survprobscouple(2, 3, ixyear) 
             
             !Probabilities of transition from just womman alive to other states (including death)
             survprobscouple(3, 1, ixyear) = 0.0_rk
             survprobscouple(3, 2, ixyear) = 0.0_rk
             survprobscouple(3, 3, ixyear) = survprobswoman(ixyear)             
             survprobscouple(3, 4, ixyear) = 1.0_rk - survprobscouple(2, 1, ixyear) - survprobscouple(2, 2, ixyear) - survprobscouple(2, 3, ixyear) 
         end do
         
       end subroutine get3waysurvivalprob
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
 !This is a 'cdf' in inverted commas as there is no natural ordering for the household composition
 !But it allows me to draw realisations using the routine I wrote for income
 
       subroutine get3waysurvivalcdf(numyears, survprobscouple, survcdfscouple)
         implicit none
         integer :: numyears
         real (kind=rk), intent(in) :: survprobscouple(3, 4, numyears)
         real (kind=rk), intent(out) :: survcdfscouple(4, 4, numyears)
         
         integer :: ixyear 
         integer :: ixhhcomp
         
         do ixyear = 1, numyears, 1
             do ixhhcomp = 1, 3                 
                 survcdfscouple(ixhhcomp, 1, ixyear) = survprobscouple(ixhhcomp, 1, ixyear)
                 survcdfscouple(ixhhcomp, 2, ixyear) = survcdfscouple(ixhhcomp, 1, ixyear) + survprobscouple(ixhhcomp, 2, ixyear)
                 survcdfscouple(ixhhcomp, 3, ixyear) = survcdfscouple(ixhhcomp, 2, ixyear) + survprobscouple(ixhhcomp, 3, ixyear)
                 survcdfscouple(ixhhcomp, 4, ixyear) = 1.0_rk
             end do
             survcdfscouple(4, 1, ixyear) = 0.0_rk 
             survcdfscouple(4, 2, ixyear) = 0.0_rk 
             survcdfscouple(4, 3, ixyear) = 0.0_rk 
             survcdfscouple(4, 4, ixyear) = 1.0_rk 
         end do
         
       end subroutine get3waysurvivalcdf
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
    real (kind=rk) function taxben(todayinfo, taxsys)
        implicit none
                            
                           
! Arguments
        type(taxtype), intent (in) :: taxsys
        type (typetodayinfo), intent(in) :: todayinfo
 
        taxben = childben(todayinfo, taxsys)
          
        
    end function taxben
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
    real (kind=rk) function childben(todayinfo, taxsys) !This allows for non integer number of children
     
     implicit none

! Arguments
        type(taxtype), intent (in) :: taxsys
        type (typetodayinfo), intent(in) :: todayinfo
     
         if (todayinfo%numkids.eq.0.0_rk) then
            childben = 0.0_rk
         else if ((todayinfo%numkids.gt.0.0_rk).and.(todayinfo%numkids.le.1.0_rk)) then
            childben = taxsys%childBenRate1 * todayinfo%numkids
         else if (todayinfo%numkids.gt.1.0_rk) then
            childben = taxsys%childBenRate1 + taxsys%childBenRate2 * (todayinfo%numkids - 1.0_rk)
         else
            write(*,*) 'Number of children cannot be negative'
            stop
         end if
        
    end function childben
    
! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
subroutine calequivscale(numyears, numkids, numeqkids)
  implicit none
  
  integer, intent(in) :: numyears
  real (kind=rk), intent(in) :: numkids(numyears)
 real (kind=rk), intent(out) :: numeqkids(numyears)
 
 numeqkids = 0.2_rk * numkids
  
end subroutine calequivscale        

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!        

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!        
subroutine convertcontinuous_to_discrete(points, allearnings, opt_realised)
    use globalvalues
    
    type (grids) :: points
    real (kind = rk), intent(in) :: allearnings(workChoices,points%ar1by4,points%numyears)
    type(typeopt_realisations)  :: opt_realised

    !For program
    real (kind=rk) :: relevantearningsvec(points%ar1) 
    integer :: lowerbound, upperbound
    
    integer :: ixyear, ixyear2
    integer :: ixperson
    integer :: nearestnode
    integer :: lowestnode
    logical :: haventfoundit
    integer :: firstyearobservedworking
                         
       if (points%womanearnprop .gt. 0.0000001_rk) then
        write(*,*) 'Trying to turn observed, continuous income, into discrete income'
        write(*,*) 'Womens income is not 0. In this case (project optimality) it should be'
        stop
       end if
        
       
       !First ignore the fact that some of these are zeros - indicating unemployment
       do ixyear = 1, points%numyears
                lowerbound = points%ar1by2+1
                upperbound = points%ar1by3
                relevantearningsvec = allearnings(2, lowerbound:upperbound, ixyear)
                
                call findingridr(relevantearningsvec, points%ar1, opt_realised%realisedearnings(ixyear), nearestnode, lowestnode) 
                opt_realised%d_realisedearnings(ixyear) = allearnings(2, nearestnode, ixyear)
                opt_realised%d_earningnode(ixyear) = nearestnode +  points%ar1by2 !Because with no explicit female earnings we are in the third quadrant of the grid             
        end do ! ixyear
        
        
        !Now, taking account of unemployment
        do ixyear = 1, points%numyears
            if (opt_realised%realisedunemp(ixyear).eq.1) then
                if (ixyear.ne.1) then
                    if (opt_realised%realisedunemp(ixyear-1).ne.1) then !If we weren't unemployed in the previous then we know productivity (which is the same today but with
                    !points%ar1 added to the node to indicate that we have a particular level of productivity without getting a job offer
                        opt_realised%d_earningnode(ixyear) = opt_realised%d_earningnode(ixyear - 1) + points%ar1
                    else if (opt_realised%realisedunemp(ixyear-1).eq.1) then !last period we were unemployed
                         opt_realised%d_earningnode(ixyear) =  opt_realised%d_earningnode(ixyear - 1)
                    end if
                 else if (ixyear.eq.1) then
                    !Find the first age at which we see these guys in work
                    haventfoundit = .true.
                    firstyearobservedworking = -9999
                    do ixyear2 = 2, points%numyears                        
                        if ((haventfoundit).and.(opt_realised%realisedunemp(ixyear2).ne.1)) then !i.e. we've just found the first year where work is observed
                            firstyearobservedworking = ixyear2
                            haventfoundit = .false.
                        end if
                    end do
                    opt_realised%d_earningnode(ixyear) = opt_realised%d_earningnode(firstyearobservedworking) + points%ar1
                 end if
                    
            opt_realised%d_realisedearnings(ixyear) = 0.0_rk !Either way realised earnings are 0
            end if        
        
        end do ! ixyear
                   
      
end subroutine convertcontinuous_to_discrete

!-----!
!Now a few routines to get male and female share of earnings - for the tax function
!-----!

! ---------------------------------------------------------------------------------------------------------!      
! ---------------------------------------------------------------------------------------------------------!      

! ---------------------------------------------------------------------------------------------------------!      
! ---------------------------------------------------------------------------------------------------------!      


! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!

! ---------------------------------------------------------------------------------------------------------!
! ---------------------------------------------------------------------------------------------------------!
real (kind=rk) function funcUnempPayment(points, numkids)
  implicit none
  
   type(grids), intent(in) :: points
   real (kind=rk), intent(in) :: numkids
   
   funcUnempPayment = points%unemppay + numkids * (points%unempKids)
   
end function funcUnempPayment

!---------------------------------------------------------------------------------------------------------------!
!---------------------------------------------------------------------------------------------------------------!

real (kind=rk) function getInterest(ass,  points, todayinfo,  cash, housing,   nonHInterest, totalInterest, components)
  
    implicit none
    real (kind=rk), intent(in) :: ass !cash on hand (including today's income)
    type(grids), intent(in) :: points !interest rate coefficients
    type(typetodayinfo), intent(in) :: todayinfo
    real (kind=rk), intent(out) :: cash, housing
    real (kind=rk), intent(out), optional :: nonHInterest,totalInterest, components(4)
    
    ! For program
    real (kind=rk) :: liqShare
    real (kind=rk) :: housRIncLeverage, mort, grossH, housingYieldIn2002Prices
       
    
    !If method == 1, then we simply have a constant interest rate
    if (points%intMeth.eq.1) then
        getInterest = points%rate * ass        
         if (present(nonHInterest)) then
            nonHInterest = getInterest
         end if
        if (present(totalInterest)) totalInterest = getInterest
          
         cash = ass
         housing = 0.0_rk

        if (present(components)) then
            components(1) = points%rate * cash 
            components(2) = 0.0_rk                
            components(3) = 0.0_rk
            components(4) = 0.0_rk
        end if
            
         
    elseif (points%intMeth.eq.2) then ! otherwise we have an interest rate increasing in asset holding
            

            
            if (todayinfo%ixage .eq. 64) then
                if (ass.gt.0.0_rk) then
                    liqShare = (ass - todayinfo%housingIfOver65) / ( ass) ! haven't yet deducted housing from assets
                else
                    liqShare = 1.0_rk
                end if                
                cash = ass - todayinfo%housingIfOver65        
                housing = todayinfo%housingIfOver65               
            else if (todayinfo%ixage .gt. 64) then
                if (ass.gt.0.0_rk) then
                    liqShare = ass / (todayinfo%housingIfOver65 + ass)
                else
                    liqShare = 1.0_rk
                end if                
                cash = ass
                housing = todayinfo%housingIfOver65
            else 
                liqShare = getLiqShare(points, todayinfo%ixage, todayinfo%over65, ass )
                housing =  (1.0_rk - liqShare) * (ass)
                cash = ass - housing                
            end if            
            
            
           if (todayinfo%leverage .lt. 0.0000000000000001_rk) then
               mort = 0.0_rk
           else      
            mort = housing / ( (1.0_rk/todayinfo%leverage) - 1)
           end if
           
            grossH = housing + mort
            
            
            housingYieldIn2002Prices = points%housYield / ((1+points%housCG)**todayinfo%yearsFrom2002) 
            
            if (todayinfo%ixage .le. 64) then
                getInterest = points%rate * cash  + grossH * (points%housCG + housingYieldIn2002Prices) - points%mortR * mort
                if (present(totalInterest)) totalInterest = getInterest
            else 
               getInterest = points%rate * cash  + grossH * (housingYieldIn2002Prices) ! - points%mortR * mort    ! From 65 I add the capital gain net of mortgage directly onto the capital value           
               if (present(totalInterest))  totalInterest = points%rate * cash  + grossH * (points%housCG + housingYieldIn2002Prices) - points%mortR * mort ! but I need total interest for the eule equation
            end if
            
            if (present(components)) then
                components(1) = points%rate * cash 
                components(2) = grossH * points%housCG                 
                components(3) = grossH * housingYieldIn2002Prices
                components(4) = points%mortR * mort 
            end if
            
            
            
            

          
             if (present(nonHInterest)) then
                nonHInterest = points%rate * cash
             end if
       
                      
    end if        
       
                 
    
  if ((getInterest.lt.0).and.((points%housCG + points%housYield) .ge. points%mortR)) then
     write(*,*) 'Interest rate is negative where it shouldnt be - error in getInterest'
     write(*,*) getInterest, points%housCG, points%housYield, ass, cash, grossH, mort

   end if
  
end function getInterest

!-----------------------------------------------------------------------------------------------!
!-----------------------------------------------------------------------------------------------!





real (kind=rk) function getLiqShare(points, ixage, over65, ass)
  implicit none
    
    type(grids), intent(in) :: points !interest rate coefficients
    integer :: ixage
    real (kind=rk) :: over65    
    real (kind=rk), intent(in) :: ass !cash on hand (including today's income)
    real (kind=rk) :: test
 
    if (points%intMeth.eq.2) then
          getLiqShare = (points%portb0) 
          getLiqShare = getLiqShare + (points%portwealth * (ass/1000.0_rk))  
          getLiqShare = getLiqShare + (points%portwealth2 * ((ass/1000.0_rk)**2)) 
        
    else 
            getLiqShare = 1.0_rk
    end if

   if (getLiqShare .lt. 0.0_rk) then
        getLiqShare = 0.0_rk     
   elseif (getLiqShare .gt. 1.0_rk) then
        getLiqShare = 1.0_rk     
   end if    

   if (ass .gt. 1000000.0_rk) then
          getLiqShare = (points%portb0) 
          getLiqShare = getLiqShare + (points%portwealth * (1000000/1000.0_rk))  
          getLiqShare = getLiqShare + (points%portwealth2 * ((1000000/1000.0_rk)**2)) 
       
        getLiqShare =  getLiqShare + (ass / 1000000000)
       
   end if
   
end function getLiqShare

!-----------------------------------------------------------------------------------------------!
!-----------------------------------------------------------------------------------------------!

subroutine setTodayLeverageAndOver65(todayinfo,  points)
use globalvalues
type(typetodayinfo), intent(inout) :: todayinfo
type(grids), intent(in) :: points
real (kind = rk) :: debtOverGrossH

todayinfo%leverage = points%lev0 + points%lev1 * todayinfo%ixage + points%lev2 * (todayinfo%ixage**2)

if ((todayinfo%leverage.lt.0).or.(todayinfo%ixage.gt.65)) then
    todayinfo%leverage  = 0.0_rk  
end if


if (todayinfo%ixage.ge.65) todayinfo%over65 = 1.0_rk
if (todayinfo%ixage.lt.65) todayinfo%over65 = 0.0_rk

end subroutine setTodayLeverageAndOver65
!-----------------------------------------------------------------------------------------------!
!-----------------------------------------------------------------------------------------------!

            end module routines_specific
