
    subroutine simulate(points, ixtype, numsims, allearnings,dumar1shocks, ar1pdf, ar1cdf, doprintsimdetail, assgrid, dcgrid, pengrid, housgrid,&
                         policy, exval, opt_realised, failmaxoversims, failaveoversims, simstat, &
                        expdiscutil,allcpaths, alllpaths, hhcomplist)

      use globalvalues
      use routines_generic
      use routines_specific
      use pension
      use precisions
      use types

      implicit none

      type (grids), intent (in) :: points
      integer, intent(in) :: ixtype
      integer, intent (in) :: numsims
      real (kind=rk), intent (in) :: allearnings(workChoices, points%ar1by4, points%numyears)
      real (kind=rk), intent (in) :: dumar1shocks(points%ar1by4, points%numyears)
      real (kind=rk), intent (in) :: ar1pdf(points%ar1by4, points%ar1by4, points%numyears)
      real (kind=rk), intent (in) :: ar1cdf(points%ar1by4, points%ar1by4, points%numyears)
      logical, intent(in) :: doprintsimdetail
      real (kind=rk), intent (in) :: assgrid(points%ass, points%numyears+1)
      real (kind=rk), intent (in) :: dcgrid(points%dc, claimAge-19)
      real (kind=rk), intent (in) :: pengrid(points%pen), housgrid(points%housPoints, (65-19):points%numyears)
      type (policy_funcs), intent (in) :: policy
      type (val_funcs), intent (in) :: exval
      type(typeopt_realisations), intent(in)  :: opt_realised      
      real (kind=rk), intent (out) :: failmaxoversims(4)
      real (kind=rk), intent (out) :: failaveoversims(4)
      type (seriesstats), intent (out) :: simstat
      real (kind=rk), intent(out) :: expdiscutil
      real (kind=rk), intent(out) :: allcpaths(points%numyears, numsims)
      integer, intent(out) :: alllpaths(points%numyears, numsims)
      integer, intent(out)  :: hhcomplist(points%numyears, numsims)

            
!Paths of everything for all simulated individuals. Not spitting out at the moment.       
      integer :: licon(points%numyears, numsims)
      real (kind=rk) :: sdfsim(points%numyears, numsims)
      real (kind=rk) :: alleqcpaths(points%numyears, numsims)
      real (kind=rk), dimension(points%numyears, numsims) :: apathsEnd, apathsStart, cashPaths, housingPaths       
      real (kind=rk) :: allypaths(points%numyears, numsims)
      real (kind=rk) :: allearnpaths(points%numyears, numsims)
      real (kind=rk) :: alldcsave(points%numyears, numsims)
      real (kind=rk) :: allgcpaths(points%numyears, numsims) 
      real (kind=rk) :: allscpaths(points%numyears, numsims) 
      real (kind=rk) :: allsppaths(points%numyears, numsims) 
      real (kind=rk) :: alldbpaths(points%numyears, numsims), alldcpaths(points%numyears, numsims)
      real (kind=rk) :: shockDecPaths(points%numyears, numsims)
      real (kind=rk), dimension(points%numyears, numsims) :: cashInterest, housingCG, housingYield, mortgage               
      integer :: allar1locpaths(points%numyears, numsims)
      integer :: alldcpaths_node(points%numyears, numsims)
      integer :: allinftwork(points%numyears, numsims)
      integer :: allinptwork(points%numyears, numsims)
      real (kind=rk) :: alive(points%numyears, numsims) !This will be used for the weights in the summary statistics
      real (kind=rk) :: alldcflow_val(points%numyears, numsims)
      real (kind=rk) :: totalass_val(points%numyears, numsims)
      real (kind=rk) :: alldcfund_val(points%numyears, numsims)
      integer :: unemp(points%numyears, numsims)
      real (kind=rk) :: grossinc(points%numyears, numsims)
      real (kind=rk) :: utilitysim(points%numyears, numsims)      
      real (kind=rk) :: taxandbensim(points%numyears, numsims)  
      real (kind=rk) :: taxtoday
      real (kind=rk) :: bentoday 
      type (typetomvalfuncs) :: tomvalfuncs
      type (typetodayinfo) :: todayinfo

      !For program
!indexes
      integer ixtoday, todayage, ixsims

      real (kind=rk) :: optimalc
      real (kind=rk) :: cashonhand
      real (kind=rk) :: exvalprimetoday
      real (kind=rk) :: ass_today, ass_tom
      real (kind=rk) :: dc_today, dc_tom
      real (kind=rk) :: todaygrossearning
      real (kind=rk) :: peninc_today_bc
      real (kind=rk) :: todaypolc_preret(points%ass, points%dc)
      real (kind=rk) :: todaypolc_postret(points%ass, points%pen)
      integer :: lowerloc_dc
      integer :: lowerloc_peninc
      real (kind=rk) :: shocksval(points%numyears, numsims)
      integer :: shockslist(points%numyears, numsims)
      integer :: todayarshockloc, tomarshocklock
      real (kind=rk) :: normdrawsfordc(points%numyears, numsims)
      real (kind=rk) :: unifdrawsfordc(points%numyears, numsims)
      integer :: ar1ForQuant, nearestAr1Quant, lowerAr1Quant
      
!For derivative
      real (kind=rk) :: exvaltomupp
      real (kind=rk) :: exvaltomlow
      real (kind=rk) :: marguttoday
      real (kind=rk) :: tompmat(points%ar1by4)

!to sort
      real (kind=rk) :: todaydcsave
      integer :: scratch
      integer :: ixproblem
      integer :: lowerloc_ass
      logical :: cornercheck(3)
      type (utilityparams) :: params
      real (kind=rk) :: todaynetincome
      real (kind=rk) :: todaynetincomeprePenCred
      real (kind=rk) :: finaldcval
      integer :: startingshock 
      real (kind=rk) :: todayunemppayment
      real (kind=rk) ::   todaygrossincome, todaygrossearnlessdc


      type (typetomgrids) :: tomgrids
      type (typetomstates) :: tomstates
      real (kind=rk) :: dbtoday
      integer :: ixhhcomp
      real (kind=rk) :: scratchhhcomps(4)
      real (kind=rk) :: scratchhhcompsbyyears(4,points%numyears-1 )
      real (kind=rk) :: scratchhhcompval(points%numyears, numsims)
      integer :: oldixhhcomp
      integer :: temp
      real (kind=rk) :: interest, housing, cash, interestForTax, interest_up, housComponents(4)
      integer :: housingloc
      real (kind=rk) :: housingVal, scratchrk
      integer  :: scratchint, lowerloc_hous      
      real (kind=rk) :: expecvalue
      integer :: ixassnode2, ixhhcomp2, ixpenpoint2, ixhouspoint2
      !For tax schedule
      real (kind=rk) :: manshare
     real (kind=rk) :: liqShare
    integer :: numhhcompsToRunThrough1

! -----------------------------------------------------------------!
! Allocations
! -----------------------------------------------------------------!
allocate (tomgrids%ass(points%ass))
allocate (tomgrids%dc(points%dc))
allocate (tomgrids%pen(points%pen))
allocate (tomgrids%hous(points%housPoints))
allocate (tomvalfuncs%val_post_apc(points%ass, points%pen, 3))           
allocate (tomvalfuncs%val_ar1Int_pre_adc(points%ass, points%dc, 3))
allocate (tomvalfuncs%mu_post_apc(points%ass, points%pen, 3))       
allocate (tomvalfuncs%mu_post_apch(points%ass, points%pen,points%housPoints, 3))       
allocate (tomvalfuncs%mu_arInt_pre_adc(points%ass, points%dc, 3))
allocate (tomvalfuncs%eval_pre_adlq(points%ass,3,workChoices, points%numdcch))
allocate (tomvalfuncs%linEmu_pre_adlq(points%ass,3,workChoices, points%numdcch))
allocate (tomvalfuncs%linEmu_post_ap(points%ass, points%pen))
allocate (tomvalfuncs%linEmu_post_aph(points%ass, points%pen, points%housPoints))
allocate (tomvalfuncs%val_post_adch(points%ass, points%pen, points%housPoints, 3))



!I am now hardocing the option to integrate outside optimisation as I do that in this file
     todayinfo%dcalreadyintegrated = .true.
            
!Set the parameters
      params = points%params
      
! Set the stochastic draws      
      shockslist(:, 1) = opt_realised%d_earningnode !we take the draws from the data
      normdrawsfordc(:, 1) = opt_realised%dcgr
           
! Force everyone to be alive for all period - we are matching data to, at the latest, age 62 and assume no death until 64, so this is appropriate
      hhcomplist = 1


      ixproblem = 0
      do ixsims = 1, numsims, 1
        
        ass_tom = 0.0_rk !NB assets at the beginning of the first period
        tomstates%pen = 0.0_rk    
        dc_tom = 0.0_rk
        tomstates%windfall = 0.0_rk
        dbtoday = 0.0_rk
        ixhhcomp = 1
        
        do ixtoday = 1, points%numyears, 1
        
          todayage = ixtoday + 19
          todayinfo%yearsFrom2002 = opt_realised%yob  + todayage - 2002
          todayinfo%ixage = todayage                    
          todayinfo%numkids = points%numkids(ixtoday)                            
          todayinfo%ixhhcomp = ixhhcomp
          todayinfo%ixtoday = ixtoday     
          todayinfo%shockDecile = -99.0_rk

        ! Next see whats max hhcomp state for next year (if can't be dead don't integrate) 
        if (todayage.lt.(points%firstageatwhichdeath-1)) then
            numhhcompsToRunThrough1 = 1
        else 
            numhhcompsToRunThrough1 = points%numhhcomp
        end if     

          
          tomgrids%ass = assgrid(:, ixtoday+1)
          tomgrids%pen = pengrid
           
           
         call setparamsthisyear(points%numyears,points%numeqkids(ixtoday), ixtoday, todayage, params)
         call setTodayLeverageAndOver65(todayinfo, points)      
       
       
          ass_today = ass_tom + tomstates%windfall         
            
          !Household composition and shocks
          oldixhhcomp = ixhhcomp 
          ixhhcomp = hhcomplist(ixtoday, ixsims)
          

          if ((oldixhhcomp.eq.1).and.((ixhhcomp.eq.2).or.(ixhhcomp.eq.3))) then
            peninc_today_bc = tomstates%pen*points%penpropinherit 
          else 
            peninc_today_bc = tomstates%pen 
          end if         
           
          if (ixhhcomp.eq.4) then 
            alive(ixtoday, ixsims) = 0.0_rk
          else
            alive(ixtoday, ixsims) = 1.0_rk
          end if     
       
          params%equivscaleinv =  params%equivscaleinvvec(ixhhcomp)
          params%equivscale = 1.0_rk/  params%equivscaleinv     

          
          todayarshockloc = shockslist(ixtoday, ixsims)
          
          !!!
          ! Correct todayarhockloc for different grid after retirement and get the decile for pension processes
          !!!
          if (todayage.gt.claimAge) then
              if (todayarshockloc.le.points%ar1)                                          todayarshockloc = todayarshockloc
              if ((todayarshockloc.gt.points%ar1).and.(todayarshockloc.le.points%ar1by2))      todayarshockloc =  todayarshockloc - points%ar1
              if ((todayarshockloc.gt.points%ar1by2).and.(todayarshockloc.le.points%ar1by3))    todayarshockloc = todayarshockloc - points%ar1by2                                        
              if ((todayarshockloc.gt.points%ar1by3))                                    todayarshockloc =  todayarshockloc - points%ar1by3   
              
               call findingridr(points%popEarQuantsAt64, points%ar1, allearnings(2, todayarshockloc, 64-19), nearestAr1Quant, lowerAr1Quant)  ! What were earnings at age 64
                todayinfo%shockDecile = 10* real(nearestAr1Quant, rk)/real(points%ar1, rk)            

          end if
        
        call checkShockDecile
                
          todayinfo%ixar1node = todayarshockloc
          allar1locpaths(ixtoday, ixsims) = todayarshockloc

          !!!!!-----------------------------------------------------------------------!
          !!!!! Get an unemployment indicator
          !!!!!-----------------------------------------------------------------------!
              if (todayage.le.claimAge) then
                if ((todayarshockloc.le.points%ar1).or.((todayarshockloc.gt.points%ar1by2).and.(todayarshockloc.le.points%ar1by3))) then
                        unemp(ixtoday, ixsims) = 0
                else  if (todayage.gt.claimAge) then
                        unemp(ixtoday, ixsims) = 0
                else            
                        unemp(ixtoday, ixsims) = 1
                end if
              end if


          !!!!!-----------------------------------------------------------------------!
          !!!!! Get tomorrow's probability distribution over A11
          !!!!!-----------------------------------------------------------------------!

           tompmat = ar1pdf(todayarshockloc, :, min(points%numyears,ixtoday+1))
           call checktompmat


!-----------------------------------------------------!
!Get the discrete choices and select out the relevant policy functions
!-----------------------------------------------------!		  		 
 
 !--------------------------
 ! Labour supply decision
 !--------------------------
             if  ((todayage.le.claimAge).and.(unemp(ixtoday, ixsims).ne.1))  then
                   alllpaths(ixtoday,ixsims) = 0 
                   if (contEarn) then
                       todaygrossearning = opt_realised%realisedearnings(ixtoday)
                   else
                       todaygrossearning = allearnings(2, todayarshockloc, ixtoday) 
                   end if
                   todayinfo%ixleis = 2
             else 
                   alllpaths(ixtoday,ixsims) = 2 
                   todaygrossearning = 0.0_rk
                   todayinfo%ixleis = 1
             end if            
       


!--------------------------
! DC saving decision
!--------------------------
          if (todayage.lt.(claimAge + 1)) then
             ! Where are we on the grids
            dc_today = dc_tom
            call findingridr(assgrid(:,ixtoday), points%ass, ass_today, scratch, lowerloc_ass)
            call findingridr(dcgrid(:,ixtoday), points%dc, dc_today, scratch, lowerloc_dc)

            call discrete_policy_pre(policy%dc_pre, cornercheck(3), alldcpaths_node(ixtoday,ixsims))
            alldcflow_val(ixtoday, ixsims) = points%alldcchoice(alldcpaths_node(ixtoday,ixsims))

            
            todayinfo%ixdcchoice =  alldcpaths_node(ixtoday,ixsims)
            
          else !we've claimed pension
            dc_today = 0.0_rk
            call findingridr(assgrid(:,ixtoday), points%ass, ass_today, scratch, lowerloc_ass)
            call findingridr(pengrid, points%pen, tomstates%pen, scratch, lowerloc_peninc)
            alldcpaths_node(ixtoday, ixsims) = 1
            alldcflow_val(ixtoday, ixsims) = points%alldcchoice(alldcpaths_node(ixtoday,ixsims))
          end if

        !DC saving this period
          todaydcsave = todaygrossearning*(alldcflow_val(ixtoday,ixsims))
          alldcsave(ixtoday, ixsims) = todaydcsave
          tomstates%dc = dc_today + todaydcsave
 
          

 !--------------------------
 ! Tomorrow's pension, windfall and housing
 !--------------------------
          if (todayage.lt.claimAge) then
                tomstates%pen = 0.0_rk
                tomstates%windfall = 0.0_rk
                todayinfo%housingIfOver65 = 0.0_rk

          else if (todayage.eq.claimAge) then       
                ! Annuity rate is based on today's decision, having survived today, but with stochastic mortality tomorrow
                tomstates%pen =  pension_dc(points,points%fairannuity(todayage-19, ixhhcomp), todayage, points%oneminusdclumpsumprop*(dc_today+todaydcsave))
                tomstates%windfall = points%dclumpsumprop*(dc_today+todaydcsave)
                finaldcval = dc_today + todaydcsave  
                
                ! Set housing values
                housingloc = lowerloc_ass   !this is the node that gives us housing - never changes              
                liqShare = getLiqShare(points, todayinfo%ixage, todayinfo%over65, ass_today )
                housingVal =  (1.0_rk - liqShare) * (ass_today)
                cash = ass_today - housing                     
                
                todayinfo%housingIfOver65 = housingVal 
                tomgrids%hous = housgrid(:, ixtoday+1)
                tomstates%hous = housingVal
          else if (todayage.gt.claimAge) then                                
                tomstates%windfall = 0.0_rk

                
                ! From this age, cg net of mortgage is added onto the housin stock
                housingVal = housingVal + housingCG(ixtoday-1, ixsims) - mortgage(ixtoday-1, ixsims)
                todayinfo%housingIfOver65 = housingVal 
                

                
                if (ixtoday.eq.points%numyears) then
                    tomgrids%hous = housgrid(:, ixtoday ) 
                else
                    tomgrids%hous = housgrid(:, ixtoday + 1)
                end if          

                tomstates%hous = housingVal
          end if           


         
!----------------------------------------------------
! Value and marginal utility functions
!----------------------------------------------------
          if (todayage.lt.claimAge) then
                !Get continuation expected (ar1 shock) value function a							
                tomvalfuncs%val_ar1Int_pre_adc  = getexpoverar1(points,exval%pre(:,:,:,:,ixtoday+1), tompmat, points%lowerar1nodeforint, points%upperar1nodeforint) 
                tomvalfuncs%mu_arInt_pre_adc  = getexpoverar1(points,exval%mu_pre(:,:,:,:,ixtoday+1), tompmat, points%lowerar1nodeforint, points%upperar1nodeforint) 
                
                tomgrids%dc = dcgrid(:, ixtoday+1)
                    
           !---------------------------------------!   
            ! Get expected value function
            !---------------------------------------!   
            do ixassnode2 = 1, points%ass
                do ixhhcomp2 = 1, numhhcompsToRunThrough1 
                expecvalue = &
                getexpoverdc(points, tomgrids,tomvalfuncs%val_ar1Int_pre_adc(:,:, ixhhcomp2),tomstates%dc,0.0_rk, & ! In vfi, I have stock + flow in these two arguments. The sum is already done here into stock
                        assgrid(ixassnode2,ixtoday+1), ixhhcomp2) 
                                  
                        tomvalfuncs%eval_pre_adlq(ixassnode2,ixhhcomp2,todayinfo%ixleis,  todayinfo%ixdcchoice  ) = expecvalue                                                                
                                  
                               
            !---------------------------------------!   
            ! Get inverted expected  marginal utility
            !---------------------------------------!   
                    expecvalue = &
                    getexpoverdc(points, tomgrids,tomvalfuncs%mu_arInt_pre_adc(:,:, ixhhcomp2),tomstates%dc,0.0_rk, &
                            assgrid(ixassnode2,ixtoday+1), ixhhcomp2)
                                    
                                        
                    tomvalfuncs%linEmu_pre_adlq(ixassnode2,ixhhcomp2,todayinfo%ixleis,  todayinfo%ixdcchoice  ) = margfelicity_inv(expecvalue ,params)         !Inversion                                                       
                 end do
            end do
            
                
                
          else ! if (todayage.lt.claimAge) then
                if (todayage.eq.claimAge) then
                      if (todayarshockloc.le.points%ar1)                                          tomarshocklock = todayarshockloc
                      if ((todayarshockloc.gt.points%ar1).and.(todayarshockloc.le.points%ar1by2))      tomarshocklock =  todayarshockloc - points%ar1
                      if ((todayarshockloc.gt.points%ar1by2).and.(todayarshockloc.le.points%ar1by3))    tomarshocklock = todayarshockloc - points%ar1by2                                        
                      if ((todayarshockloc.gt.points%ar1by3))                                    tomarshocklock =  todayarshockloc - points%ar1by3                
                else ! so todayage is greater than claimAge
                      tomarshocklock = todayarshockloc
                end if 
                
                tomvalfuncs%val_post_apc = exval%post(:,  :, tomarshocklock, housingloc, :,ixtoday+1)  
                tomvalfuncs%val_post_adch = exval%post(:,  :, tomarshocklock, :, :,ixtoday+1)  
                
                
                tomvalfuncs%mu_post_apch = exval%mu_post(:,  :, tomarshocklock, :, :,ixtoday+1) 
                   ! Expected inverted marginal utility tomorrow
                        do ixassnode2 = 1, points%ass 
                            do ixpenpoint2 = 1, points%pen
                                do ixhouspoint2 = 1, points%housPoints
                                   if (todayinfo%ixage.eq.(points%numyears+19)) then
                                    else if (todayage.lt.(points%firstageatwhichdeath-1)) then
                                      tomvalfuncs%linEmu_post_aph(ixassnode2, ixpenpoint2, ixhousPoint2)    = margfelicity_inv(tomvalfuncs%mu_post_apch(ixassnode2,ixpenpoint2, ixhousPoint2, 1),params)   
                                    else    
                                        tomvalfuncs%linEmu_post_aph(ixassnode2, ixpenpoint2, ixhousPoint2)    = margfelicity_inv(   &
                                        points%survprobs3way(todayinfo%ixhhcomp, 1, todayinfo%ixtoday)*tomvalfuncs%mu_post_apch(ixassnode2,ixpenpoint2, ixhousPoint2, 1) +  & 
                                        points%survprobs3way(todayinfo%ixhhcomp, 2, todayinfo%ixtoday)*tomvalfuncs%mu_post_apch(ixassnode2,ixpenpoint2, ixhousPoint2,2) + &
                                        points%survprobs3way(todayinfo%ixhhcomp, 3, todayinfo%ixtoday)*tomvalfuncs%mu_post_apch(ixassnode2,ixpenpoint2, ixhousPoint2,3) ,params)
                                   end if
                                   
                                end do
                            end do
                        end do            
          end if
        
          
!-----------------------------------------------------!
!Getting income and cash on hand
!-----------------------------------------------------!

!Unemployment income
          if ((unemp(ixtoday, ixsims).eq.1).and.(todayage.lt.points%statepenage)) then
             todayunemppayment = funcUnempPayment(points, todayinfo%numkids)     
          else
             todayunemppayment = 0.0_rk
          end if


!Get pension income tomorrow
          dbtoday = db(points, todayage, opt_realised, todayinfo%shockDecile, todayinfo)  
          
         
          ! I do this to get interestForTax  - the last argument
          interest = getInterest(ass_today,points, todayinfo, cash, housing, nonHInterest= interestForTax, components = housComponents)   
          cashInterest(ixtoday, ixsims) = housComponents(1)
          housingCG(ixtoday, ixsims) = housComponents(2)
          housingYield(ixtoday, ixsims) = housComponents(3)
          mortgage(ixtoday, ixsims) = housComponents(4)         
          
          todaygrossincome = points%uncondtrans + todaygrossearning+ peninc_today_bc+ statepen(points,todayage,opt_realised,todayinfo%shockDecile, todayinfo)+ &
                                 db(points,todayage,opt_realised,todayinfo%shockDecile, todayinfo) -todaydcsave + todayunemppayment + interest         ! grossincome does not include dc saving                          
          
          todaygrossearnlessdc = todaygrossearning - todaydcsave
          
          manshare = points%manshare(ixtoday)  
         

          if (noPenTaxAdv) then
                !DC saving comes out of grosss income, then we subtract DC
                todaynetincomeprePenCred = netfamilyincome_new(todaygrossincome +  todaydcsave - peninc_today_bc, todaygrossearnlessdc, interest, interestForTax, & 
                                points%tax2005, manshare, todayage)  - todaydcsave + peninc_today_bc ! grossincome does not include dc saving 
                if (todaynetincomeprePenCred .le. 0_rk) then !Set income to zero and save all income
                    todaynetincomeprePenCred = 0.0_rk
                    todaydcsave = netfamilyincome_new(todaygrossincome +  todaydcsave - peninc_today_bc, todaygrossearnlessdc, interest, interestForTax, & 
                                points%tax2005, manshare, todayage) + peninc_today_bc
                    
                    tomstates%dc = dc_today + todaydcsave                
                end if
         else
          todaynetincomeprePenCred = netfamilyincome_new(todaygrossincome , todaygrossearnlessdc, interest, interestForTax, & 
                                points%tax2005, manshare, todayage)   ! grossincome does not include dc saving
           end if
                                      
          
                    
           
          todaynetincome = todaynetincomeprePenCred & 
                                     + guarcred(points%pc,todaynetincomeprePenCred, cash + dc_today, todayage,ixhhcomp) &
                                     + savcred(points%pc,todaynetincomeprePenCred, cash + dc_today, todayage,ixhhcomp) &
                                     + taxben(todayinfo, points%tax2005)

          grossinc(ixtoday, ixsims) = todaygrossincome + todaydcsave +guarcred(points%pc,todaynetincomeprePenCred, cash + dc_today, todayage,ixhhcomp) + &
                                            savcred(points%pc,todaynetincomeprePenCred, cash + dc_today, todayage,ixhhcomp) 
        
          
!Cash on hand this period
          cashonhand = ass_today + todaynetincome 
          tomstates%cash = cashonhand


          
!Get optimal consumption by maximising the value function
          call getconfromval            
            
          if (optimalc.gt.cashonhand) then ! if it stil doesn't work will need to set optimalc = cashonhand
          if (optimalc.gt.(cashonhand + 0.01_rk)) then !indication of a problem if its more than 0.01 greater        
            ixproblem = ixproblem + 1
            write (*, *) 'Problem in simulate. optimalc is more than 0.01 greater than cashonhand', ixproblem
            write (*, *) 'Period', ixtoday, 'Sim.', ixsims
            write (*, *) optimalc-cashonhand            
          end if
            optimalc = cashonhand
          end if


!Get tax and benefit payments
          taxtoday = todaygrossincome - todaynetincomeprePenCred 
          bentoday = statepen(points,todayage,opt_realised,todayinfo%shockDecile,todayinfo) + guarcred(points%pc,todaynetincomeprePenCred, cash + dc_today, todayage,ixhhcomp) &
                                     + savcred(points%pc,todaynetincomeprePenCred, ass_today + dc_today, todayage,ixhhcomp) + todayunemppayment &
                                     + db(points,todayage,opt_realised,todayinfo%shockDecile,todayinfo) + taxben(todayinfo, points%tax2005)
                                     
          if (hhcomplist(ixtoday, ixsims).ne.4) then !i.e. sim is alive 
           taxandbensim(ixtoday, ixsims) = taxtoday - bentoday
           utilitysim(ixtoday, ixsims) = felicity(optimalc, alllpaths(ixtoday,ixsims), params)
          else if (hhcomplist(ixtoday, ixsims).eq.4) then !i.e. sim is dead
           taxandbensim(ixtoday, ixsims) = 0.0_rk
           utilitysim(ixtoday, ixsims) = 0.0_rk
          else
            write(*,*) 'Error in simulate - hhcompdead is neither zero nor 1'
            stop
          end if

          apathsStart(ixtoday, ixsims) = ass_today
          cashPaths(ixtoday, ixsims) = cash
          housingPaths(ixtoday, ixsims) = housing                        
          apathsEnd(ixtoday, ixsims) = cashonhand - optimalc
          
          if (todayage.eq.64) then
                apathsEnd(ixtoday, ixsims) = apathsEnd(ixtoday, ixsims) - housingVal  
          end if
          
!Fill in paths 
          allcpaths(ixtoday, ixsims) = optimalc
          alleqcpaths(ixtoday, ixsims) = optimalc*params%equivscaleinv
          allypaths(ixtoday, ixsims) = todaynetincome 
          allearnpaths(ixtoday, ixsims) = todaygrossearning
          allgcpaths(ixtoday, ixsims) = guarcred(points%pc,todaynetincomeprePenCred, cash + dc_today, todayage,ixhhcomp)
          allscpaths(ixtoday, ixsims) = savcred(points%pc,todaynetincomeprePenCred, cash + dc_today, todayage,ixhhcomp)
          allsppaths(ixtoday, ixsims) = statepen(points,todayage,opt_realised, todayinfo%shockDecile, todayinfo)
          alldbpaths(ixtoday, ixsims) = db(points,todayage,opt_realised, todayinfo%shockDecile, todayinfo)
          alldcpaths(ixtoday, ixsims) = peninc_today_bc
          
          shockDecPaths(ixtoday, ixsims)  = todayinfo%shockDecile
          
!Fill in dc fund val at end of period
          if (todayage.le.64) alldcfund_val(ixtoday, ixsims) = dc_today + todaydcsave
          if (todayage.gt.64) alldcfund_val(ixtoday, ixsims) = peninc_today_bc/points%fairannuity(ixtoday, ixhhcomp)
 
 !Fill in total (sum of DC and cash) at the end of the period
           totalass_val(ixtoday, ixsims) = apathsEnd(ixtoday, ixsims) + alldcfund_val(ixtoday, ixsims)  
                    
!-----------------------!
!Get next period states  
!-----------------------!
!Assets next period
          ass_tom = apathsEnd(ixtoday, ixsims) ! recall no interest here as that's included in income

!DC fund next period
          dc_tom = (1+normdrawsfordc(ixtoday,ixsims))*alldcfund_val(ixtoday, ixsims)

!Get sdfsim path
          if ((apathsEnd(ixtoday,ixsims).lt.2.0_rk).or.(points%dontchecksdfs)) then !If liquidity constrained
            licon(ixtoday, ixsims) = 1
            sdfsim(ixtoday, ixsims) = -1
          else
            licon(ixtoday, ixsims) = 0

!Get the derivative of the value function
            exvaltomupp = contvalue(points, (ass_tom+0.001_rk),tomstates,tomgrids,tomvalfuncs,todayinfo,params)
            exvaltomlow = contvalue(points, (ass_tom-0.001_rk),tomstates,tomgrids,tomvalfuncs,todayinfo, params)
            exvalprimetoday = (exvaltomupp-exvaltomlow)/(0.002_rk)

            
            
!First of all get marginal utility at the realised points 
            marguttoday = margfelicity(optimalc, alllpaths(ixtoday,ixsims), params)
            sdfsim(ixtoday, ixsims) = marguttoday/(params%beta*exvalprimetoday) ! no rate here as interest is now income, so its effect is in exvalprime
          end if
                    

         
        end do !ixtoday
      end do !ixsims

     

     


!Get summary statistics
      call sumstats(allcpaths, points%numyears, numsims, simstat%con%mean, simstat%con%sdev, simstat%con%skew, &
        simstat%con%kurt, simstat%con%min, simstat%con%max, weights = alive)
      call sumstats(alleqcpaths, points%numyears, numsims, simstat%eqcon%mean, simstat%eqcon%sdev, simstat%eqcon%skew, &
        simstat%eqcon%kurt, simstat%eqcon%min, simstat%eqcon%max, weights = alive)
      call sumstats(apathsEnd, points%numyears, numsims, simstat%ass%mean, simstat%ass%sdev, simstat%ass%skew, &
        simstat%ass%kurt, simstat%ass%min, simstat%ass%max, weights = alive)
      call sumstats(apathsStart, points%numyears, numsims, simstat%assStart%mean, simstat%assStart%sdev, simstat%assStart%skew, &
        simstat%assStart%kurt, simstat%assStart%min, simstat%assStart%max, weights = alive)
      call sumstats(cashPaths, points%numyears, numsims, simstat%cashPaths%mean, simstat%cashPaths%sdev, simstat%cashPaths%skew, &
        simstat%cashPaths%kurt, simstat%cashPaths%min, simstat%cashPaths%max, weights = alive)
      call sumstats(housingPaths, points%numyears, numsims, simstat%housingPaths%mean, simstat%housingPaths%sdev, simstat%housingPaths%skew, &
        simstat%housingPaths%kurt, simstat%housingPaths%min, simstat%housingPaths%max, weights = alive)
      call sumstats(allearnpaths, points%numyears, numsims, simstat%earn%mean, simstat%earn%sdev, simstat%earn%skew, &
        simstat%earn%kurt, simstat%earn%min, simstat%earn%max, weights = alive)
      call sumstats(allypaths, points%numyears, numsims, simstat%inc%mean, simstat%inc%sdev, simstat%inc%skew, &
        simstat%inc%kurt, simstat%inc%min, simstat%inc%max, weights = alive)
      call sumstats(grossinc, points%numyears, numsims, simstat%grossinc%mean, simstat%grossinc%sdev, simstat%grossinc%skew, &
        simstat%grossinc%kurt, simstat%grossinc%min, simstat%grossinc%max, weights = alive)
      call sumstats(allgcpaths, points%numyears, numsims, simstat%guarcred%mean, simstat%guarcred%sdev, simstat%guarcred%skew, &
        simstat%guarcred%kurt, simstat%guarcred%min, simstat%guarcred%max, weights = alive)
      call sumstats(allscpaths, points%numyears, numsims, simstat%savcred%mean, simstat%savcred%sdev, simstat%savcred%skew, &
        simstat%savcred%kurt, simstat%savcred%min, simstat%savcred%max, weights = alive)
      call sumstats(allsppaths, points%numyears, numsims, simstat%statepen%mean, simstat%statepen%sdev, simstat%statepen%skew, &
        simstat%statepen%kurt, simstat%statepen%min, simstat%statepen%max, weights = alive)
      call sumstats(alldbpaths, points%numyears, numsims, simstat%db%mean, simstat%db%sdev, simstat%db%skew, &
        simstat%db%kurt, simstat%db%min, simstat%db%max, weights = alive)
      call sumstats(alldcpaths, points%numyears, numsims, simstat%dc%mean, simstat%dc%sdev, simstat%dc%skew, &
        simstat%dc%kurt, simstat%dc%min, simstat%dc%max, weights = alive)
      call sumstats(alldcflow_val, points%numyears, numsims, simstat%dcflowval%mean, simstat%dcflowval%sdev, &
        simstat%dcflowval%skew, simstat%dcflowval%kurt, simstat%dcflowval%min, simstat%dcflowval%max, weights = alive)
      call sumstats(alldcfund_val, points%numyears, numsims, simstat%dcstockval%mean, simstat%dcstockval%sdev, &
        simstat%dcstockval%skew, simstat%dcstockval%kurt, simstat%dcstockval%min, simstat%dcstockval%max, weights = alive)
      call sumstats(totalass_val, points%numyears, numsims, simstat%totass%mean, simstat%totass%sdev, &
        simstat%totass%skew, simstat%totass%kurt, simstat%totass%min, simstat%totass%max, weights = alive)
      call sumstats(utilitysim, points%numyears, numsims, simstat%utility%mean, simstat%utility%sdev, &
        simstat%utility%skew, simstat%utility%kurt, simstat%utility%min, simstat%utility%max, weights = alive)        
      call sumstats(real(alllpaths,rk), points%numyears, numsims, simstat%leis%mean, simstat%leis%sdev, &
        simstat%leis%skew, simstat%leis%kurt, simstat%leis%min, simstat%leis%max, weights = alive)
      call sumstats(real(licon,rk), points%numyears, numsims, simstat%licon%mean, simstat%licon%sdev, &
        simstat%licon%skew, simstat%licon%kurt, simstat%licon%min, simstat%licon%max, weights = alive)
      call sumstats(real(unemp,rk), points%numyears, numsims, simstat%unemp%mean, simstat%unemp%sdev, &
        simstat%unemp%skew, simstat%unemp%kurt, simstat%unemp%min, simstat%unemp%max, weights = alive)
      call sumstats(sdfsim, points%numyears, numsims, simstat%sdf%mean, simstat%sdf%sdev, simstat%sdf%skew, &
        simstat%sdf%kurt, simstat%sdf%min, simstat%sdf%max, weights = alive)
      call sumstats(real(licon,rk), points%numyears, numsims, simstat%licon%mean, simstat%licon%sdev, simstat%licon%skew, &
        simstat%licon%kurt, simstat%licon%min, simstat%licon%max, weights = alive)
      call sumstats(shockDecPaths, points%numyears, numsims, simstat%shockDec%mean, simstat%shockDec%sdev, simstat%shockDec%skew, &
        simstat%shockDec%kurt, simstat%shockDec%min, simstat%shockDec%max, weights = alive)
      call sumstats(cashInterest, points%numyears, numsims, simstat%cashInterest%mean, simstat%cashInterest%sdev, simstat%cashInterest%skew, &
            simstat%cashInterest%kurt, simstat%cashInterest%min, simstat%cashInterest%max, weights = alive)           
      call sumstats(housingCG, points%numyears, numsims, simstat%housingCG%mean, simstat%housingCG%sdev, simstat%housingCG%skew, &
        simstat%housingCG%kurt, simstat%housingCG%min, simstat%housingCG%max, weights = alive)
      call sumstats(housingYield, points%numyears, numsims, simstat%housingYield%mean, simstat%housingYield%sdev, simstat%housingYield%skew, &
               simstat%housingYield%kurt, simstat%housingYield%min, simstat%housingYield%max, weights = alive)
      call sumstats(mortgage, points%numyears, numsims, simstat%mortgage%mean, simstat%mortgage%sdev, simstat%mortgage%skew, &
                simstat%mortgage%kurt, simstat%mortgage%min, simstat%mortgage%max, weights = alive)
      
      call checksdfsim(points, sdfsim, licon, failmaxoversims, failaveoversims)

! If solving for beta, store simualted asset and dc
        if (solveForBeta) then
            cashSim = simstat%cashPaths%mean(ageData - 19)
            penSim = simstat%dcstockval%mean(ageData - 19)
            housingSim = simstat%housingPaths%mean(ageData - 19) 
            nonpenSim = simstat%assStart%mean(ageData - 19) 
        end if
        

      
! -----------------------------------------------------------------!
! Dellocations
! -----------------------------------------------------------------!
deallocate (tomgrids%ass)
deallocate (tomgrids%dc)
deallocate (tomgrids%pen)
deallocate (tomgrids%hous)
deallocate (tomvalfuncs%val_post_apc)
deallocate (tomvalfuncs%val_ar1Int_pre_adc)
deallocate (tomvalfuncs%mu_post_apc)
deallocate (tomvalfuncs%mu_arInt_pre_adc)
deallocate (tomvalfuncs%eval_pre_adlq)
deallocate (tomvalfuncs%linEmu_pre_adlq)
deallocate (tomvalfuncs%linEmu_post_ap)
deallocate (tomvalfuncs%mu_post_apch)
deallocate (tomvalfuncs%linEmu_post_aph)
deallocate (tomvalfuncs%val_post_adch)

        

    contains
!---------------------------------------------------------------------------------------------------------!
      subroutine getconfromval
        implicit none
        real (kind=rk) :: todayvalue
        real (kind=rk) :: todayvalue_frommax
        real (kind=rk) :: tomdcgridsim(points%dc)
        real (kind=rk) :: upperbound, lowerbound
        logical :: doGuess
        
        
        todayinfo%leistoday = alllpaths(ixtoday,ixsims)
       
        upperbound = cashonhand 
                
        if (todayage.eq.64) then
                                  upperbound = upperbound -  todayinfo%housingIfOver65             
        end if
                  
      
        lowerbound = max(cashonhand - assgrid(points%ass, ixtoday), 0.01_rk)

        doGuess = .false.
        
        todayvalue_frommax = getMax_fast(points, lowerbound, upperbound, 0.0_rk, doGuess, optimalc, tomstates, tomgrids, &
           tomvalfuncs ,todayinfo, params)

      end subroutine getconfromval
      !---------------------------------------------------------------------------------------------------------!

      subroutine discrete_policy_pre(particularpol_pre, allcornerssame, policy)
        use routines_generic
        implicit none
        integer , intent (in) :: particularpol_pre(points%ass, points%dc, points%ar1by4 &
          ,points%numhhcomp, claimAge-19)
        logical, intent (out) :: allcornerssame
        integer, intent (out) :: policy(1)
        integer :: point(4)
        real (kind=rk) :: distance(4)
        logical :: inplay(4)
        integer :: ix
        integer :: lowerloc_cumul 
        
        lowerloc_cumul = 0
        
        do ix = 1, 4
          inplay(ix) = .true.
        end do

        if ((lowerloc_ass.eq.0) .or. (lowerloc_ass.eq.points%ass)) then
          if (lowerloc_ass.eq.0) lowerloc_ass = 1
          inplay(2) = .false.
          inplay(4) = .false.
        end if

        if ((lowerloc_dc.eq.0) .or. (lowerloc_dc.eq.points%dc)) then
          if (lowerloc_dc.eq.0) lowerloc_dc = 1
          inplay(3) = .false.
          inplay(4) = .false.
        end if


        if (inplay(1)) point(1) = particularpol_pre(lowerloc_ass, lowerloc_dc, todayarshockloc, &
          ixhhcomp, ixtoday)
        if (inplay(2)) point(2) = particularpol_pre(lowerloc_ass+1, lowerloc_dc, todayarshockloc, &
          ixhhcomp,ixtoday)
        if (inplay(3)) point(3) = particularpol_pre(lowerloc_ass, lowerloc_dc+1, todayarshockloc, &
          ixhhcomp,ixtoday)
        if (inplay(4)) point(4) = particularpol_pre(lowerloc_ass+1, lowerloc_dc+1, todayarshockloc, &
         ixhhcomp, ixtoday)
         
         
         distance = huge(distance)

        if (inplay(1)) distance(1) = dist2(ass_today, assgrid(lowerloc_ass,ixtoday)) + dist2(dc_today, dcgrid(lowerloc_dc,ixtoday))
        if (inplay(2)) distance(2) = dist2(ass_today, assgrid(lowerloc_ass+1,ixtoday)) + dist2(dc_today, dcgrid(lowerloc_dc,ixtoday))

        if (inplay(3)) distance(3) = dist2(ass_today, assgrid(lowerloc_ass,ixtoday)) + dist2(dc_today, dcgrid(lowerloc_dc+1,ixtoday))
        if (inplay(4)) distance(4) = dist2(ass_today, assgrid(lowerloc_ass+1,ixtoday)) + dist2(dc_today, dcgrid(lowerloc_dc+1,ixtoday))



        if (maxval(point,mask=inplay).eq.minval(point,mask=inplay)) then
          allcornerssame = .true.
          policy = point(minloc(distance,mask=inplay))
        else
          allcornerssame = .false.
          policy = point(minloc(distance,mask=inplay))
        end if
      end subroutine discrete_policy_pre
!---------------------------------------------------------------------------------------------------------!
!---------------------------------------------------------------------------------------------------------!

!---------------------------------------------------------------------------------------------------------!
!---------------------------------------------------------------------------------------------------------!
subroutine  checktompmat
              !Check - Debug
              if (sum(tompmat).lt.0.999_rk) then 
                  write(*,*) 'Error in simulate, probabilities not adding up to 1' 
                  write(*,*) ixsims,ixtoday 
                  write(*,*) sum(tompmat)
 !                 stop
              end if 
end subroutine              
!---------------------------------------------------------------------------------------------------------!
!---------------------------------------------------------------------------------------------------------!
    subroutine checkShockDecile
          !!!!!-----------------------------------------------------------------------!
          !Check the shock percentile, and replace
          !!!!!-----------------------------------------------------------------------!
           if (todayage.le.claimAge) then
                if (todayinfo%shockDecile .gt. 0.0_rk) then
                       write(*,*) 'error in simulate, shockDecile should be negative for  before claimAge'
                       stop
                end if
           else
                if ((todayinfo%shockDecile.lt.0.0_rk).or.(todayinfo%shockDecile.gt.10.0_rk)) then
                       write(*,*) 'error in simulate, shockDecile should be between zero and 1'            
                       stop
                end if       
           end if            
    end subroutine checkShockDecile
!---------------------------------------------------------------------------------------------------------!
!---------------------------------------------------------------------------------------------------------!
    end subroutine simulate

